searchData={"items":[{"type":"module","title":"OpenaiEx","doc":"`OpenaiEx` is an Elixir library that provides a community-maintained client for the OpenAI API.\n\nThe library closely follows the structure of the [official OpenAI API client libraries](https://platform.openai.com/docs/api-reference)\nfor [Python](https://github.com/openai/openai-python)\nand [JavaScript](https://github.com/openai/openai-node),\nmaking it easy to understand and reuse existing documentation and code.","ref":"OpenaiEx.html"},{"type":"function","title":"OpenaiEx.list_query_fields/0","doc":"","ref":"OpenaiEx.html#list_query_fields/0"},{"type":"function","title":"OpenaiEx.new/2","doc":"Creates a new OpenaiEx struct with the specified token and organization.\n\nSee https://platform.openai.com/docs/api-reference/authentication for details.","ref":"OpenaiEx.html#new/2"},{"type":"function","title":"OpenaiEx.new_file/1","doc":"Create file parameter struct for use in multipart requests.\n\nOpenAI API has endpoints which need a file parameter, such as Files and Audio.\nThis function creates a file parameter given a name (optional) and content or a local file path.","ref":"OpenaiEx.html#new_file/1"},{"type":"function","title":"OpenaiEx.with_assistants_beta/1","doc":"","ref":"OpenaiEx.html#with_assistants_beta/1"},{"type":"module","title":"OpenaiEx.Audio","doc":"This module provides an implementation of the OpenAI audio API. The API reference can be found at https://platform.openai.com/docs/api-reference/audio.","ref":"OpenaiEx.Audio.html"},{"type":"module","title":"API Fields - OpenaiEx.Audio","doc":"The following fields can be used as parameters when creating a new audio request:\n\n- `:file`\n- `:model`\n- `:language`\n- `:prompt`\n- `:response_format`\n- `:temperature`","ref":"OpenaiEx.Audio.html#module-api-fields"},{"type":"function","title":"OpenaiEx.Audio.new/1","doc":"Creates a new audio request with the given arguments.","ref":"OpenaiEx.Audio.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.Audio.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the audio request.","ref":"OpenaiEx.Audio.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Audio.new/1","doc":"A map containing the fields of the audio request.\n\nThe `:file` and `:model` fields are required.","ref":"OpenaiEx.Audio.html#new/1-returns"},{"type":"function","title":"OpenaiEx.Audio.transcribe/2","doc":"Calls the audio transcription endpoint.","ref":"OpenaiEx.Audio.html#transcribe/2"},{"type":"function","title":"Arguments - OpenaiEx.Audio.transcribe/2","doc":"- `openai`: A map containing the OpenAI configuration.\n- `audio`: A map containing the audio request.","ref":"OpenaiEx.Audio.html#transcribe/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Audio.transcribe/2","doc":"A map containing the audio response.\n\nSee https://platform.openai.com/docs/api-reference/audio/create for more information.","ref":"OpenaiEx.Audio.html#transcribe/2-returns"},{"type":"function","title":"OpenaiEx.Audio.translate/2","doc":"Calls the audio translation endpoint.","ref":"OpenaiEx.Audio.html#translate/2"},{"type":"function","title":"Arguments - OpenaiEx.Audio.translate/2","doc":"- `openai`: A map containing the OpenAI configuration.\n- `audio`: A map containing the audio request.","ref":"OpenaiEx.Audio.html#translate/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Audio.translate/2","doc":"A map containing the audio response.\n\nSee https://platform.openai.com/docs/api-reference/audio/create for more information.","ref":"OpenaiEx.Audio.html#translate/2-returns"},{"type":"module","title":"OpenaiEx.Beta.Assistant","doc":"This module provides an implementation of the OpenAI assistants API. The API reference can be found at https://platform.openai.com/docs/api-reference/assistants.","ref":"OpenaiEx.Beta.Assistant.html"},{"type":"module","title":"API Fields - OpenaiEx.Beta.Assistant","doc":"The following fields can be used as parameters when creating a new assistant:\n\n- `:model`\n- `:name`\n- `:description`\n- `:instructions`\n- `:tools`\n- `:file_ids`\n- `:metadata`","ref":"OpenaiEx.Beta.Assistant.html#module-api-fields"},{"type":"function","title":"OpenaiEx.Beta.Assistant.create/2","doc":"Calls the assistant 'create' endpoint.","ref":"OpenaiEx.Beta.Assistant.html#create/2"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Assistant.create/2","doc":"- `openai`: The OpenAI configuration.\n- `assistant`: The assistant request, as a map with keys corresponding to the API fields.","ref":"OpenaiEx.Beta.Assistant.html#create/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Assistant.create/2","doc":"A map containing the API response.\n\nSee https://platform.openai.com/docs/api-reference/assistants/createAssistant for more information.","ref":"OpenaiEx.Beta.Assistant.html#create/2-returns"},{"type":"function","title":"OpenaiEx.Beta.Assistant.delete/2","doc":"Calls the assistant delete endpoint.","ref":"OpenaiEx.Beta.Assistant.html#delete/2"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Assistant.delete/2","doc":"- `openai`: The OpenAI configuration.\n- `assistant_id`: The ID of the file to delete.","ref":"OpenaiEx.Beta.Assistant.html#delete/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Assistant.delete/2","doc":"A map containing the fields of the assistant delete response.\n\nhttps://platform.openai.com/docs/api-reference/assistants/deleteAssistant","ref":"OpenaiEx.Beta.Assistant.html#delete/2-returns"},{"type":"function","title":"OpenaiEx.Beta.Assistant.list/2","doc":"Returns a list of assistant objects.\n\nhttps://platform.openai.com/docs/api-reference/assistants/listAssistants","ref":"OpenaiEx.Beta.Assistant.html#list/2"},{"type":"function","title":"OpenaiEx.Beta.Assistant.new/1","doc":"Creates a new assistants request with the given arguments.","ref":"OpenaiEx.Beta.Assistant.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Assistant.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the assistant request.","ref":"OpenaiEx.Beta.Assistant.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Assistant.new/1","doc":"A map containing the fields of the assistant request.\n\nThe `:model` field is required.\n\nExample usage:\n\n    iex> _request = OpenaiEx.Beta.Assistant.new(model: \"gpt-4-turbo\")\n    %{model: \"gpt-4-turbo\"}","ref":"OpenaiEx.Beta.Assistant.html#new/1-returns"},{"type":"function","title":"OpenaiEx.Beta.Assistant.new_list/1","doc":"Creates a new list assistants request with the given arguments.","ref":"OpenaiEx.Beta.Assistant.html#new_list/1"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Assistant.new_list/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the list assistants request.","ref":"OpenaiEx.Beta.Assistant.html#new_list/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Assistant.new_list/1","doc":"A map containing the fields of the list assistants request.","ref":"OpenaiEx.Beta.Assistant.html#new_list/1-returns"},{"type":"function","title":"OpenaiEx.Beta.Assistant.retrieve/2","doc":"Calls the assistant retrieve endpoint.","ref":"OpenaiEx.Beta.Assistant.html#retrieve/2"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Assistant.retrieve/2","doc":"- `openai`: The OpenAI configuration.\n- `assistant_id`: The ID of the assistant to retrieve.","ref":"OpenaiEx.Beta.Assistant.html#retrieve/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Assistant.retrieve/2","doc":"A map containing the fields of the file retrieve response.\n\nhttps://platform.openai.com/docs/api-reference/assistants/getAssistant","ref":"OpenaiEx.Beta.Assistant.html#retrieve/2-returns"},{"type":"function","title":"OpenaiEx.Beta.Assistant.update/3","doc":"Calls the assistant update endpoint.","ref":"OpenaiEx.Beta.Assistant.html#update/3"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Assistant.update/3","doc":"- `openai`: The OpenAI configuration.\n- `assistant_id`: The ID of the assistant to update.\n- `assistant`: The assistant request, as a map with keys corresponding to the API fields.","ref":"OpenaiEx.Beta.Assistant.html#update/3-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Assistant.update/3","doc":"A map containing the API response.\n\nSee https://platform.openai.com/docs/api-reference/assistants/modifyAssistant for more information.","ref":"OpenaiEx.Beta.Assistant.html#update/3-returns"},{"type":"module","title":"OpenaiEx.Beta.Assistant.File","doc":"This module provides an implementation of the OpenAI assistants files API. The API reference can be found at https://platform.openai.com/docs/api-reference/assistants.","ref":"OpenaiEx.Beta.Assistant.File.html"},{"type":"module","title":"API Fields - OpenaiEx.Beta.Assistant.File","doc":"The following fields can be used as parameters for the assistant files API:\n\n- `:assistant_id`\n- `:file_id`","ref":"OpenaiEx.Beta.Assistant.File.html#module-api-fields"},{"type":"function","title":"OpenaiEx.Beta.Assistant.File.create/2","doc":"Calls the assistant file create endpoint.","ref":"OpenaiEx.Beta.Assistant.File.html#create/2"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Assistant.File.create/2","doc":"- `openai`: The OpenAI configuration.\n- `params`: A map containing the fields of the assistant file create request.","ref":"OpenaiEx.Beta.Assistant.File.html#create/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Assistant.File.create/2","doc":"A map containing the fields of the created assistant file object.\n\nhttps://platform.openai.com/docs/api-reference/assistants/createAssistantFile","ref":"OpenaiEx.Beta.Assistant.File.html#create/2-returns"},{"type":"function","title":"OpenaiEx.Beta.Assistant.File.delete/2","doc":"Calls the assistant file delete endpoint.","ref":"OpenaiEx.Beta.Assistant.File.html#delete/2"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Assistant.File.delete/2","doc":"- `openai`: The OpenAI configuration.\n- `params`: A map containing the fields of the assistant file delete request.","ref":"OpenaiEx.Beta.Assistant.File.html#delete/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Assistant.File.delete/2","doc":"A map containing the fields of the assistant file delete response.\n\nhttps://platform.openai.com/docs/api-reference/assistants/deleteAssistantFile","ref":"OpenaiEx.Beta.Assistant.File.html#delete/2-returns"},{"type":"function","title":"OpenaiEx.Beta.Assistant.File.list/2","doc":"","ref":"OpenaiEx.Beta.Assistant.File.html#list/2"},{"type":"function","title":"OpenaiEx.Beta.Assistant.File.new/1","doc":"Creates a new assistant file request with the given arguments.","ref":"OpenaiEx.Beta.Assistant.File.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Assistant.File.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the assistant file request.","ref":"OpenaiEx.Beta.Assistant.File.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Assistant.File.new/1","doc":"A map containing the fields of the assistant file request.","ref":"OpenaiEx.Beta.Assistant.File.html#new/1-returns"},{"type":"function","title":"OpenaiEx.Beta.Assistant.File.new_list/1","doc":"Lists the files that belong to the specified assistant.\n\nhttps://platform.openai.com/docs/api-reference/assistants/listAssistantFiles","ref":"OpenaiEx.Beta.Assistant.File.html#new_list/1"},{"type":"function","title":"OpenaiEx.Beta.Assistant.File.retrieve/2","doc":"Calls the assistant file retrieve endpoint.","ref":"OpenaiEx.Beta.Assistant.File.html#retrieve/2"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Assistant.File.retrieve/2","doc":"- `openai`: The OpenAI configuration.\n- `params`: A map containing the fields of the assistant file retrieve request.","ref":"OpenaiEx.Beta.Assistant.File.html#retrieve/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Assistant.File.retrieve/2","doc":"A map containing the fields of the specificied assistant file object.\n\nhttps://platform.openai.com/docs/api-reference/assistants/getAssistantFile","ref":"OpenaiEx.Beta.Assistant.File.html#retrieve/2-returns"},{"type":"module","title":"OpenaiEx.Beta.Thread","doc":"This module provides an implementation of the OpenAI threads API. The API reference can be found at https://platform.openai.com/docs/api-reference/threads.","ref":"OpenaiEx.Beta.Thread.html"},{"type":"module","title":"API Fields - OpenaiEx.Beta.Thread","doc":"The following fields can be used as parameters when creating a new assistant:\n\n- `:messages`\n- `:metadata`","ref":"OpenaiEx.Beta.Thread.html#module-api-fields"},{"type":"function","title":"OpenaiEx.Beta.Thread.create/2","doc":"Calls the thread create endpoint.","ref":"OpenaiEx.Beta.Thread.html#create/2"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Thread.create/2","doc":"- `openai`: The OpenAI configuration.\n- `params`: A map containing the fields of the thread create request.","ref":"OpenaiEx.Beta.Thread.html#create/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Thread.create/2","doc":"A map containing the fields of the created thread object.\n\nhttps://platform.openai.com/docs/api-reference/threads/createThread","ref":"OpenaiEx.Beta.Thread.html#create/2-returns"},{"type":"function","title":"OpenaiEx.Beta.Thread.delete/2","doc":"Calls the thread delete endpoint.","ref":"OpenaiEx.Beta.Thread.html#delete/2"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Thread.delete/2","doc":"- `openai`: The OpenAI configuration.\n- `params`: A map containing the fields of the thread delete request.","ref":"OpenaiEx.Beta.Thread.html#delete/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Thread.delete/2","doc":"A map containing the fields of the thread delete response.\n\nhttps://platform.openai.com/docs/api-reference/threads/deleteThread","ref":"OpenaiEx.Beta.Thread.html#delete/2-returns"},{"type":"function","title":"OpenaiEx.Beta.Thread.new/1","doc":"Creates a new threads request with the given arguments.","ref":"OpenaiEx.Beta.Thread.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Thread.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the threads request.","ref":"OpenaiEx.Beta.Thread.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Thread.new/1","doc":"A map containing the fields of the threads request.","ref":"OpenaiEx.Beta.Thread.html#new/1-returns"},{"type":"function","title":"OpenaiEx.Beta.Thread.retrieve/2","doc":"Calls the thread retrieve endpoint.","ref":"OpenaiEx.Beta.Thread.html#retrieve/2"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Thread.retrieve/2","doc":"- `openai`: The OpenAI configuration.\n- `thread_id`: The ID of the thread to retrieve.","ref":"OpenaiEx.Beta.Thread.html#retrieve/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Thread.retrieve/2","doc":"A map containing the fields of the specificied thread object.\n\nhttps://platform.openai.com/docs/api-reference/threads/getThread","ref":"OpenaiEx.Beta.Thread.html#retrieve/2-returns"},{"type":"function","title":"OpenaiEx.Beta.Thread.update/3","doc":"Calls the thread update endpoint.","ref":"OpenaiEx.Beta.Thread.html#update/3"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Thread.update/3","doc":"- `openai`: The OpenAI configuration.\n- `thread_id`: The ID of the thread to update.\n- `params`: The thread update request, as a map with keys corresponding to the API fields.","ref":"OpenaiEx.Beta.Thread.html#update/3-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Thread.update/3","doc":"A map containing the fields of the modified thread.\n\nhttps://platform.openai.com/docs/api-reference/threads/modifyThread","ref":"OpenaiEx.Beta.Thread.html#update/3-returns"},{"type":"module","title":"OpenaiEx.Beta.Thread.Message","doc":"This module provides an implementation of the OpenAI messages API. The API\nreference can be found at https://platform.openai.com/docs/api-reference/messages.","ref":"OpenaiEx.Beta.Thread.Message.html"},{"type":"module","title":"API Fields - OpenaiEx.Beta.Thread.Message","doc":"The following fields can be used as parameters for the messages API:\n\n- `:role`\n- `:content`\n- `:file_ids`\n- `:metadata`","ref":"OpenaiEx.Beta.Thread.Message.html#module-api-fields"},{"type":"function","title":"OpenaiEx.Beta.Thread.Message.create/3","doc":"Calls the message create endpoint.","ref":"OpenaiEx.Beta.Thread.Message.html#create/3"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Thread.Message.create/3","doc":"- `openai`: The OpenAI configuration.\n- `params`: A map containing the fields of the message create request.","ref":"OpenaiEx.Beta.Thread.Message.html#create/3-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Thread.Message.create/3","doc":"A map containing the fields of the created message object.\n\nhttps://platform.openai.com/docs/api-reference/messages/createMessage","ref":"OpenaiEx.Beta.Thread.Message.html#create/3-returns"},{"type":"function","title":"OpenaiEx.Beta.Thread.Message.list/3","doc":"","ref":"OpenaiEx.Beta.Thread.Message.html#list/3"},{"type":"function","title":"OpenaiEx.Beta.Thread.Message.new/1","doc":"Creates a new message request with the given arguments.","ref":"OpenaiEx.Beta.Thread.Message.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Thread.Message.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the message request.","ref":"OpenaiEx.Beta.Thread.Message.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Thread.Message.new/1","doc":"A map containing the fields of the message request.","ref":"OpenaiEx.Beta.Thread.Message.html#new/1-returns"},{"type":"function","title":"OpenaiEx.Beta.Thread.Message.new_list/1","doc":"Lists the messages that belong to the specified thread.\n\nhttps://platform.openai.com/docs/api-reference/messages/listMessages","ref":"OpenaiEx.Beta.Thread.Message.html#new_list/1"},{"type":"function","title":"OpenaiEx.Beta.Thread.Message.retrieve/2","doc":"Calls the message retrieve endpoint.","ref":"OpenaiEx.Beta.Thread.Message.html#retrieve/2"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Thread.Message.retrieve/2","doc":"- `openai`: The OpenAI configuration.\n- `params`: A map containing the fields of the message retrieve request.","ref":"OpenaiEx.Beta.Thread.Message.html#retrieve/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Thread.Message.retrieve/2","doc":"A map containing the fields of the specificied message object.\n\nhttps://platform.openai.com/docs/api-reference/messages/getMessage","ref":"OpenaiEx.Beta.Thread.Message.html#retrieve/2-returns"},{"type":"function","title":"OpenaiEx.Beta.Thread.Message.update/2","doc":"Calls the message update endpoint.","ref":"OpenaiEx.Beta.Thread.Message.html#update/2"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Thread.Message.update/2","doc":"- `openai`: The OpenAI configuration.\n- `params`: A map containing the fields of the message update request.","ref":"OpenaiEx.Beta.Thread.Message.html#update/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Thread.Message.update/2","doc":"A map containing the fields of the message update response.\n\nhttps://platform.openai.com/docs/api-reference/messages/modifyMessage","ref":"OpenaiEx.Beta.Thread.Message.html#update/2-returns"},{"type":"module","title":"OpenaiEx.Beta.Thread.Message.File","doc":"This module provides an implementation of the OpenAI messages files API. The API reference can be found at https://platform.openai.com/docs/api-reference/messages.","ref":"OpenaiEx.Beta.Thread.Message.File.html"},{"type":"function","title":"OpenaiEx.Beta.Thread.Message.File.list/2","doc":"Lists the files that belong to the specified thread message.\n\nhttps://platform.openai.com/docs/api-reference/messages/listMessageFiles","ref":"OpenaiEx.Beta.Thread.Message.File.html#list/2"},{"type":"function","title":"OpenaiEx.Beta.Thread.Message.File.retrieve/2","doc":"Calls the message file retrieve endpoint.","ref":"OpenaiEx.Beta.Thread.Message.File.html#retrieve/2"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Thread.Message.File.retrieve/2","doc":"- `openai`: The OpenAI configuration.\n- `params`: A map containing the fields of the message file retrieve request.","ref":"OpenaiEx.Beta.Thread.Message.File.html#retrieve/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Thread.Message.File.retrieve/2","doc":"A map containing the fields of the specificied message file object.\n\nhttps://platform.openai.com/docs/api-reference/messages/getMessageFile","ref":"OpenaiEx.Beta.Thread.Message.File.html#retrieve/2-returns"},{"type":"module","title":"OpenaiEx.Beta.Thread.Run","doc":"This module provides an implementation of the OpenAI run API. The API\nreference can be found at https://platform.openai.com/docs/api-reference/runs.","ref":"OpenaiEx.Beta.Thread.Run.html"},{"type":"module","title":"API Fields - OpenaiEx.Beta.Thread.Run","doc":"The following fields can be used as parameters for the messages API:\n\n- `:assistant_id`\n- `:model`\n- `:instructions`\n- `:tools`\n- `:metadata`","ref":"OpenaiEx.Beta.Thread.Run.html#module-api-fields"},{"type":"function","title":"OpenaiEx.Beta.Thread.Run.cancel/2","doc":"","ref":"OpenaiEx.Beta.Thread.Run.html#cancel/2"},{"type":"function","title":"OpenaiEx.Beta.Thread.Run.create/2","doc":"Calls the run create endpoint.","ref":"OpenaiEx.Beta.Thread.Run.html#create/2"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Thread.Run.create/2","doc":"- `openai`: The OpenAI configuration.\n- `run`: The run request, as a map with keys corresponding to the API fields.","ref":"OpenaiEx.Beta.Thread.Run.html#create/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Thread.Run.create/2","doc":"A map containing the API response.\n\nSee https://platform.openai.com/docs/api-reference/runs/createRun for more information.","ref":"OpenaiEx.Beta.Thread.Run.html#create/2-returns"},{"type":"function","title":"OpenaiEx.Beta.Thread.Run.create_and_run/2","doc":"","ref":"OpenaiEx.Beta.Thread.Run.html#create_and_run/2"},{"type":"function","title":"OpenaiEx.Beta.Thread.Run.list/3","doc":"Returns a list of runs objects.\n\nhttps://platform.openai.com/docs/api-reference/runs/listRuns","ref":"OpenaiEx.Beta.Thread.Run.html#list/3"},{"type":"function","title":"OpenaiEx.Beta.Thread.Run.new/1","doc":"Creates a new run request with the given arguments.","ref":"OpenaiEx.Beta.Thread.Run.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Thread.Run.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the run request.","ref":"OpenaiEx.Beta.Thread.Run.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Thread.Run.new/1","doc":"A map containing the fields of the run request.\n\nThe `:thread_id` and `:assistant_id` fields are required.\n\nExample usage:\n\n    iex> _request = OpenaiEx.Beta.Thread.Run.new(thread_id: \"thread_foo\", assistant_id: \"assistant_bar\")\n    %{assistant_id: \"assistant_bar\", thread_id: \"thread_foo\"}","ref":"OpenaiEx.Beta.Thread.Run.html#new/1-returns"},{"type":"function","title":"OpenaiEx.Beta.Thread.Run.new_list/1","doc":"Creates a new list runs request with the given arguments.","ref":"OpenaiEx.Beta.Thread.Run.html#new_list/1"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Thread.Run.new_list/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the list runs request.","ref":"OpenaiEx.Beta.Thread.Run.html#new_list/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Thread.Run.new_list/1","doc":"A map containing the fields of the list runs request.","ref":"OpenaiEx.Beta.Thread.Run.html#new_list/1-returns"},{"type":"function","title":"OpenaiEx.Beta.Thread.Run.retrieve/2","doc":"Calls the run retrieve endpoint.","ref":"OpenaiEx.Beta.Thread.Run.html#retrieve/2"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Thread.Run.retrieve/2","doc":"- `openai`: The OpenAI configuration.\n- `params`: Specification of the run to retrieve.","ref":"OpenaiEx.Beta.Thread.Run.html#retrieve/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Thread.Run.retrieve/2","doc":"A map containing the fields of the run retrieve response.\n\nhttps://platform.openai.com/docs/api-reference/runs/getRun","ref":"OpenaiEx.Beta.Thread.Run.html#retrieve/2-returns"},{"type":"function","title":"OpenaiEx.Beta.Thread.Run.submit_tool_outputs/2","doc":"","ref":"OpenaiEx.Beta.Thread.Run.html#submit_tool_outputs/2"},{"type":"function","title":"OpenaiEx.Beta.Thread.Run.update/2","doc":"Calls the run update endpoint.","ref":"OpenaiEx.Beta.Thread.Run.html#update/2"},{"type":"function","title":"Arguments - OpenaiEx.Beta.Thread.Run.update/2","doc":"- `openai`: The OpenAI configuration.\n- `params`: run to update and new field values.","ref":"OpenaiEx.Beta.Thread.Run.html#update/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Beta.Thread.Run.update/2","doc":"A map containing the API response.\n\nSee https://platform.openai.com/docs/api-reference/assistants/modifyAssistant for more information.","ref":"OpenaiEx.Beta.Thread.Run.html#update/2-returns"},{"type":"module","title":"OpenaiEx.ChatCompletion","doc":"This module provides an implementation of the OpenAI chat completions API. The API reference can be found at https://platform.openai.com/docs/api-reference/chat/completions.","ref":"OpenaiEx.ChatCompletion.html"},{"type":"module","title":"API Fields - OpenaiEx.ChatCompletion","doc":"The following fields can be used as parameters when creating a new chat completion:\n\n- `:messages`\n- `:model`\n- `:frequency_penalty`\n- `:logit_bias`\n- `:max_tokens`\n- `:n`\n- `:presence_penalty`\n- `:response_format`\n- `:seed`\n- `:stop`\n- `:temperature`\n- `:top_p`\n- `:tools`\n- `:tool_choice`\n- `:user`","ref":"OpenaiEx.ChatCompletion.html#module-api-fields"},{"type":"function","title":"OpenaiEx.ChatCompletion.create/2","doc":"","ref":"OpenaiEx.ChatCompletion.html#create/2"},{"type":"function","title":"OpenaiEx.ChatCompletion.create/3","doc":"Calls the chat completion 'create' endpoint.","ref":"OpenaiEx.ChatCompletion.html#create/3"},{"type":"function","title":"Arguments - OpenaiEx.ChatCompletion.create/3","doc":"- `openai`: The OpenAI configuration.\n- `chat_completion`: The chat completion request, as a map with keys corresponding to the API fields.","ref":"OpenaiEx.ChatCompletion.html#create/3-arguments"},{"type":"function","title":"Returns - OpenaiEx.ChatCompletion.create/3","doc":"A map containing the API response.\n\nSee https://platform.openai.com/docs/api-reference/chat/completions/create for more information.","ref":"OpenaiEx.ChatCompletion.html#create/3-returns"},{"type":"function","title":"OpenaiEx.ChatCompletion.new/1","doc":"Creates a new chat completion request with the given arguments.","ref":"OpenaiEx.ChatCompletion.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.ChatCompletion.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the chat completion request.","ref":"OpenaiEx.ChatCompletion.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.ChatCompletion.new/1","doc":"A map containing the fields of the chat completion request.\n\nThe `:model` and `:messages` fields are required. The `:messages` field should be a list of maps with the `OpenaiEx.ChatMessage` structure.\n\nExample usage:\n\n    iex> _request = OpenaiEx.ChatCompletion.new(model: \"davinci\", messages: [OpenaiEx.ChatMessage.user(\"Hello, world!\")])\n    %{messages: [%{content: \"Hello, world!\", role: \"user\"}], model: \"davinci\"}\n\n    iex> _request = OpenaiEx.ChatCompletion.new(%{model: \"davinci\", messages: [OpenaiEx.ChatMessage.user(\"Hello, world!\")]})\n    %{messages: [%{content: \"Hello, world!\", role: \"user\"}], model: \"davinci\"}","ref":"OpenaiEx.ChatCompletion.html#new/1-returns"},{"type":"module","title":"OpenaiEx.ChatMessage","doc":"This module provides an elixir map wrapper around the OpenAI message JSON\nobject which is used in the chat completions and assistants APIs.\n\nThe following fields can be used as parameters when creating a new chat message:\n\n- `content`\n- `role`\n- `name`\n- `file_ids`","ref":"OpenaiEx.ChatMessage.html"},{"type":"function","title":"OpenaiEx.ChatMessage.assistant/1","doc":"Create a `ChatMessage` map with role `assistant`.\n\nExample usage:\n\n    iex> _message = OpenaiEx.ChatMessage.assistant(\"Hello, world!\")\n    %{content: \"Hello, world!\", role: \"assistant\"}","ref":"OpenaiEx.ChatMessage.html#assistant/1"},{"type":"function","title":"OpenaiEx.ChatMessage.system/1","doc":"Create a `ChatMessage` map with role `system`.\n\nExample usage:\n\n    iex> _message = OpenaiEx.ChatMessage.system(\"Hello, world!\")\n    %{content: \"Hello, world!\", role: \"system\"}","ref":"OpenaiEx.ChatMessage.html#system/1"},{"type":"function","title":"OpenaiEx.ChatMessage.tool/3","doc":"Create a `ChatMessage` map with role `function`.\n\nExample usage:\n\n    iex> _message = OpenaiEx.ChatMessage.tool(\"call_sjflkje\", \"greet\", \"Hello, world!\")\n    %{content: \"Hello, world!\", role: \"tool\", name: \"greet\", tool_call_id: \"call_sjflkje\"}","ref":"OpenaiEx.ChatMessage.html#tool/3"},{"type":"function","title":"OpenaiEx.ChatMessage.user/2","doc":"Create a `ChatMessage` map with role `user`.\n\nExample usage:\n\n    iex> _message = OpenaiEx.ChatMessage.user(\"Hello, world!\")\n    %{content: \"Hello, world!\", role: \"user\"}","ref":"OpenaiEx.ChatMessage.html#user/2"},{"type":"module","title":"OpenaiEx.Completion","doc":"This module provides an implementation of the OpenAI completions API. The API reference can be found at https://platform.openai.com/docs/api-reference/completions.","ref":"OpenaiEx.Completion.html"},{"type":"module","title":"API Fields - OpenaiEx.Completion","doc":"The following fields can be used as parameters when creating a new completion:\n\n- `:model`\n- `:prompt`\n- `:best_of`\n- `:echo`\n- `:frequency_penalty`\n- `:logit_bias`\n- `:logprobs`\n- `:max_tokens`\n- `:n`\n- `:presence_penalty`\n- `:stop`\n- `:suffix`\n- `:temperature`\n- `:top_p`\n- `:user`","ref":"OpenaiEx.Completion.html#module-api-fields"},{"type":"function","title":"OpenaiEx.Completion.create/2","doc":"","ref":"OpenaiEx.Completion.html#create/2"},{"type":"function","title":"OpenaiEx.Completion.create/3","doc":"Calls the completion 'create' endpoint.","ref":"OpenaiEx.Completion.html#create/3"},{"type":"function","title":"Arguments - OpenaiEx.Completion.create/3","doc":"- `openai`: The OpenAI configuration.\n- `completion`: The completion request, as a map with keys corresponding to the API fields.","ref":"OpenaiEx.Completion.html#create/3-arguments"},{"type":"function","title":"Returns - OpenaiEx.Completion.create/3","doc":"A map containing the API response.\n\nSee https://platform.openai.com/docs/api-reference/completions/create for more information.","ref":"OpenaiEx.Completion.html#create/3-returns"},{"type":"function","title":"OpenaiEx.Completion.new/1","doc":"Creates a new completion request with the given arguments.","ref":"OpenaiEx.Completion.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.Completion.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the completion request.","ref":"OpenaiEx.Completion.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Completion.new/1","doc":"A map containing the fields of the completion request.\n\nThe `:model` field is required.\n\nExample usage:\n\n    iex> _request = OpenaiEx.Completion.new(model: \"davinci\")\n    %{model: \"davinci\"}\n\n    iex> _request = OpenaiEx.Completion.new(%{model: \"davinci\"})\n    %{model: \"davinci\"}","ref":"OpenaiEx.Completion.html#new/1-returns"},{"type":"module","title":"OpenaiEx.Embedding","doc":"This module provides an implementation of the OpenAI embeddings API. The API reference can be found at https://platform.openai.com/docs/api-reference/embeddings.","ref":"OpenaiEx.Embedding.html"},{"type":"module","title":"API Fields - OpenaiEx.Embedding","doc":"The following fields can be used as parameters when creating a new embedding:\n\n- `:input`\n- `:model`\n- `:encoding_format`\n- `:user`","ref":"OpenaiEx.Embedding.html#module-api-fields"},{"type":"function","title":"OpenaiEx.Embedding.create/2","doc":"Calls the embedding endpoint.","ref":"OpenaiEx.Embedding.html#create/2"},{"type":"function","title":"Arguments - OpenaiEx.Embedding.create/2","doc":"- `openai`: The OpenAI configuration to use.\n- `embedding`: The embedding request to send.","ref":"OpenaiEx.Embedding.html#create/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Embedding.create/2","doc":"A map containing the fields of the embedding response.\n\nSee https://platform.openai.com/docs/api-reference/embeddings/create for more information.","ref":"OpenaiEx.Embedding.html#create/2-returns"},{"type":"function","title":"OpenaiEx.Embedding.new/1","doc":"Creates a new embedding request with the given arguments.","ref":"OpenaiEx.Embedding.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.Embedding.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the embedding request.","ref":"OpenaiEx.Embedding.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Embedding.new/1","doc":"A map containing the fields of the embedding request.\n\nThe `:model` and `:input` fields are required.\n\nExample usage:\n\n    iex> _request = OpenaiEx.Embedding.new(model: \"davinci\", input: \"This is a test\")\n    %{input: \"This is a test\", model: \"davinci\"}\n\n    iex> _request = OpenaiEx.Embedding.new(%{model: \"davinci\", input: \"This is a test\"})\n    %{input: \"This is a test\", model: \"davinci\"}","ref":"OpenaiEx.Embedding.html#new/1-returns"},{"type":"module","title":"OpenaiEx.File","doc":"This module provides an implementation of the OpenAI files API. The API reference can be found at https://platform.openai.com/docs/api-reference/files.","ref":"OpenaiEx.File.html"},{"type":"module","title":"API Fields - OpenaiEx.File","doc":"The following fields can be used as parameters for various endpoints of the API:\n\n- `:file`\n- `:purpose`\n\n- `:file_id`","ref":"OpenaiEx.File.html#module-api-fields"},{"type":"function","title":"OpenaiEx.File.create/2","doc":"Calls the file upload endpoint.","ref":"OpenaiEx.File.html#create/2"},{"type":"function","title":"Arguments - OpenaiEx.File.create/2","doc":"- `openai`: The OpenAI configuration.\n- `upload`: A map containing the fields of the file upload request.","ref":"OpenaiEx.File.html#create/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.File.create/2","doc":"A map containing the fields of the file upload response.\n\nhttps://platform.openai.com/docs/api-reference/files/upload","ref":"OpenaiEx.File.html#create/2-returns"},{"type":"function","title":"OpenaiEx.File.delete/2","doc":"Calls the file delete endpoint.","ref":"OpenaiEx.File.html#delete/2"},{"type":"function","title":"Arguments - OpenaiEx.File.delete/2","doc":"- `openai`: The OpenAI configuration.\n- `file_id`: The ID of the file to delete.","ref":"OpenaiEx.File.html#delete/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.File.delete/2","doc":"A map containing the fields of the file delete response.\n\nhttps://platform.openai.com/docs/api-reference/files/delete","ref":"OpenaiEx.File.html#delete/2-returns"},{"type":"function","title":"OpenaiEx.File.download/2","doc":"Calls the file retrieve_content endpoint.","ref":"OpenaiEx.File.html#download/2"},{"type":"function","title":"Arguments - OpenaiEx.File.download/2","doc":"- `openai`: The OpenAI configuration.\n- `file_id`: The ID of the file to retrieve the content of.","ref":"OpenaiEx.File.html#download/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.File.download/2","doc":"A map containing the fields of the file retrieve_content response.\n\nhttps://platform.openai.com/docs/api-reference/files/retrieve-content","ref":"OpenaiEx.File.html#download/2-returns"},{"type":"function","title":"OpenaiEx.File.list/1","doc":"Lists the files that belong to the user's organization.\n\nhttps://platform.openai.com/docs/api-reference/files/list","ref":"OpenaiEx.File.html#list/1"},{"type":"function","title":"OpenaiEx.File.new/1","doc":"Creates a new file retrieve / deletion / retrieve_content request with the given arguments.","ref":"OpenaiEx.File.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.File.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the file retrieve / deletion / retrieve_content request.","ref":"OpenaiEx.File.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.File.new/1","doc":"A map containing the fields of the file retrieve / deletion / retrieve_content request.\n\nThe `:file_id` field is required.","ref":"OpenaiEx.File.html#new/1-returns"},{"type":"function","title":"OpenaiEx.File.new_upload/1","doc":"Creates a new file upload request with the given arguments.","ref":"OpenaiEx.File.html#new_upload/1"},{"type":"function","title":"Arguments - OpenaiEx.File.new_upload/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the file upload request.","ref":"OpenaiEx.File.html#new_upload/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.File.new_upload/1","doc":"A map containing the fields of the file upload request.\n\nThe `:file` and `:purpose` fields are required.","ref":"OpenaiEx.File.html#new_upload/1-returns"},{"type":"function","title":"OpenaiEx.File.retrieve/2","doc":"Calls the file retrieve endpoint.","ref":"OpenaiEx.File.html#retrieve/2"},{"type":"function","title":"Arguments - OpenaiEx.File.retrieve/2","doc":"- `openai`: The OpenAI configuration.\n- `file_id`: The ID of the file to retrieve.","ref":"OpenaiEx.File.html#retrieve/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.File.retrieve/2","doc":"A map containing the fields of the file retrieve response.\n\nhttps://platform.openai.com/docs/api-reference/files/retrieve","ref":"OpenaiEx.File.html#retrieve/2-returns"},{"type":"module","title":"OpenaiEx.FineTuning.Job","doc":"This module provides an implementation of the OpenAI fine-tuning job API. The API reference can be found at https://platform.openai.com/docs/api-reference/fine-tuning.","ref":"OpenaiEx.FineTuning.Job.html"},{"type":"module","title":"API Fields - OpenaiEx.FineTuning.Job","doc":"The following fields can be used as parameters for various endpoints of the API:\n\n- `:model`\n- `:training_file`\n- `:hyperparameters`\n- `:suffix`\n- `:validation_file`\n\n- `:after`\n- `:limit`","ref":"OpenaiEx.FineTuning.Job.html#module-api-fields"},{"type":"function","title":"OpenaiEx.FineTuning.Job.cancel/2","doc":"Calls the fine-tuning job cancel endpoint.\n\nhttps://platform.openai.com/docs/api-reference/fine-tuning/cancel","ref":"OpenaiEx.FineTuning.Job.html#cancel/2"},{"type":"function","title":"OpenaiEx.FineTuning.Job.create/2","doc":"Calls the fine-tuning job creation endpoint.\n\nhttps://platform.openai.com/docs/api-reference/fine-tuning/create","ref":"OpenaiEx.FineTuning.Job.html#create/2"},{"type":"function","title":"OpenaiEx.FineTuning.Job.list/2","doc":"Calls the fine-tuning job list endpoint.\n\nhttps://platform.openai.com/docs/api-reference/fine-tuning/list","ref":"OpenaiEx.FineTuning.Job.html#list/2"},{"type":"function","title":"OpenaiEx.FineTuning.Job.list_events/2","doc":"Calls the fine-tuning job list events endpoint.\n\nhttps://platform.openai.com/docs/api-reference/fine-tuning/events","ref":"OpenaiEx.FineTuning.Job.html#list_events/2"},{"type":"function","title":"OpenaiEx.FineTuning.Job.new/1","doc":"Creates a new fine-tuning job request with the given arguments.","ref":"OpenaiEx.FineTuning.Job.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.FineTuning.Job.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the fine-tuning job request.","ref":"OpenaiEx.FineTuning.Job.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.FineTuning.Job.new/1","doc":"A map containing the fields of the fine-tuning job request.","ref":"OpenaiEx.FineTuning.Job.html#new/1-returns"},{"type":"function","title":"OpenaiEx.FineTuning.Job.retrieve/2","doc":"Calls the fine-tuning job retrieve endpoint.\n\nhttps://platform.openai.com/docs/api-reference/fine-tuning/retrieve","ref":"OpenaiEx.FineTuning.Job.html#retrieve/2"},{"type":"module","title":"OpenaiEx.Image","doc":"This module provides an implementation of the OpenAI images API. The API reference can be found at https://platform.openai.com/docs/api-reference/images.","ref":"OpenaiEx.Image.html"},{"type":"module","title":"API Fields - OpenaiEx.Image","doc":"The following fields can be used as parameters when creating a new image:\n\n- `:prompt`\n- `:model`\n- `:n`\n- `:quality`\n- `:response_format`\n- `:size`\n- `:style`\n- `:user`","ref":"OpenaiEx.Image.html#module-api-fields"},{"type":"function","title":"OpenaiEx.Image.create/2","doc":"Calls the image generation endpoint.","ref":"OpenaiEx.Image.html#create/2"},{"type":"function","title":"Arguments - OpenaiEx.Image.create/2","doc":"- `openai`: The OpenAI configuration to use.\n- `image`: The image request to send.","ref":"OpenaiEx.Image.html#create/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Image.create/2","doc":"A map containing the response from the OpenAI API.\n\nSee the [OpenAI API Create Image reference](https://platform.openai.com/docs/api-reference/images/create) for more information.","ref":"OpenaiEx.Image.html#create/2-returns"},{"type":"function","title":"OpenaiEx.Image.create_edit/2","doc":"Calls the image edit endpoint.","ref":"OpenaiEx.Image.html#create_edit/2"},{"type":"function","title":"Arguments - OpenaiEx.Image.create_edit/2","doc":"- `openai`: The OpenAI configuration to use.\n- `image_edit`: The image edit request to send.","ref":"OpenaiEx.Image.html#create_edit/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Image.create_edit/2","doc":"A map containing the response from the OpenAI API.\n\nSee the [OpenAI API Create Image Edit reference](https://platform.openai.com/docs/api-reference/images/create-edit) for more information.","ref":"OpenaiEx.Image.html#create_edit/2-returns"},{"type":"function","title":"OpenaiEx.Image.create_variation/2","doc":"Calls the image variation endpoint.","ref":"OpenaiEx.Image.html#create_variation/2"},{"type":"function","title":"Arguments - OpenaiEx.Image.create_variation/2","doc":"- `openai`: The OpenAI configuration to use.\n- `image_variation`: The image variation request to send.","ref":"OpenaiEx.Image.html#create_variation/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Image.create_variation/2","doc":"A map containing the response from the OpenAI API.\n\nSee the [OpenAI API Create Image Variation reference](https://platform.openai.com/docs/api-reference/images/create-variation) for more information.","ref":"OpenaiEx.Image.html#create_variation/2-returns"},{"type":"function","title":"OpenaiEx.Image.new/1","doc":"Creates a new image request with the given arguments.","ref":"OpenaiEx.Image.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.Image.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the image request.","ref":"OpenaiEx.Image.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Image.new/1","doc":"A map containing the fields of the image request.\n\nThe `:prompt` field is required.\n\nExample usage:\n\n    iex> _request = OpenaiEx.Image.new(prompt: \"This is a test\")\n    %{prompt: \"This is a test\"}\n\n    iex> _request = OpenaiEx.Image.new(%{prompt: \"This is a test\"})\n    %{prompt: \"This is a test\"}","ref":"OpenaiEx.Image.html#new/1-returns"},{"type":"module","title":"OpenaiEx.Image.Edit","doc":"This module provides constructors for OpenAI Image Edit API request structure. The API reference can be found at https://platform.openai.com/docs/api-reference/images/create-edit.","ref":"OpenaiEx.Image.Edit.html"},{"type":"module","title":"API Fields - OpenaiEx.Image.Edit","doc":"- `:image`\n- `:prompt`\n- `:mask`\n- `:n`\n- `:size`\n- `:response_format`\n- `:user`","ref":"OpenaiEx.Image.Edit.html#module-api-fields"},{"type":"function","title":"OpenaiEx.Image.Edit.new/1","doc":"Creates a new image edit request with the given arguments.","ref":"OpenaiEx.Image.Edit.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.Image.Edit.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the image edit request.","ref":"OpenaiEx.Image.Edit.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Image.Edit.new/1","doc":"A map containing the fields of the image edit request.\n\nThe `:image` and `:prompt` fields are required.","ref":"OpenaiEx.Image.Edit.html#new/1-returns"},{"type":"module","title":"OpenaiEx.Image.Variation","doc":"This module provides constructors for OpenAI Image Variation API request structure. The API reference can be found at https://platform.openai.com/docs/api-reference/images/create-variation.","ref":"OpenaiEx.Image.Variation.html"},{"type":"module","title":"API Fields - OpenaiEx.Image.Variation","doc":"- `:image`\n- `:n`\n- `:size`\n- `:response_format`\n- `:user`","ref":"OpenaiEx.Image.Variation.html#module-api-fields"},{"type":"function","title":"OpenaiEx.Image.Variation.new/1","doc":"Creates a new image variation request with the given arguments.","ref":"OpenaiEx.Image.Variation.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.Image.Variation.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the image variation request.","ref":"OpenaiEx.Image.Variation.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Image.Variation.new/1","doc":"A map containing the fields of the image variation request.\n\nThe `:image` field is required.","ref":"OpenaiEx.Image.Variation.html#new/1-returns"},{"type":"module","title":"OpenaiEx.Model","doc":"This module provides an implementation of the OpenAI Models API. Information about these models can be found at https://platform.openai.com/docs/models.","ref":"OpenaiEx.Model.html"},{"type":"function","title":"OpenaiEx.Model.delete/2","doc":"Deletes a specific model.\n\nhttps://platform.openai.com/docs/api-reference/fine-tunes/delete-model","ref":"OpenaiEx.Model.html#delete/2"},{"type":"function","title":"OpenaiEx.Model.list/1","doc":"Lists the available models.\n\nhttps://platform.openai.com/docs/api-reference/models/list","ref":"OpenaiEx.Model.html#list/1"},{"type":"function","title":"OpenaiEx.Model.retrieve/2","doc":"Retrieves a specific model.\n\nhttps://platform.openai.com/docs/api-reference/models/retrieve","ref":"OpenaiEx.Model.html#retrieve/2"},{"type":"module","title":"OpenaiEx.Moderation","doc":"This module provides an implementation of the OpenAI moderation API. The API reference can be found at https://platform.openai.com/docs/api-reference/moderations.","ref":"OpenaiEx.Moderation.html"},{"type":"module","title":"API Fields - OpenaiEx.Moderation","doc":"The following fields can be used as parameters when creating a new moderation:\n\n- `:input`\n- `:model`","ref":"OpenaiEx.Moderation.html#module-api-fields"},{"type":"function","title":"OpenaiEx.Moderation.create/2","doc":"Calls the moderation endpoint.","ref":"OpenaiEx.Moderation.html#create/2"},{"type":"function","title":"Arguments - OpenaiEx.Moderation.create/2","doc":"- `openai`: The OpenAI configuration to use.\n- `moderation`: The moderation request to send.","ref":"OpenaiEx.Moderation.html#create/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Moderation.create/2","doc":"A map containing the fields of the moderation response.","ref":"OpenaiEx.Moderation.html#create/2-returns"},{"type":"function","title":"OpenaiEx.Moderation.new/1","doc":"Creates a new moderation request with the given arguments.","ref":"OpenaiEx.Moderation.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.Moderation.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the moderation request.","ref":"OpenaiEx.Moderation.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Moderation.new/1","doc":"A map containing the fields of the moderation request.\n\nThe `:input` field is required.\n\nExample usage:\n\n    iex> OpenaiEx.Moderation.new(input: \"This is a test\")\n    %{\n      input: \"This is a test\"\n    }\n\n    iex> OpenaiEx.Moderation.new(%{input: \"This is a test\"})\n    %{\n      input: \"This is a test\"\n    }","ref":"OpenaiEx.Moderation.html#new/1-returns"},{"type":"extras","title":"OpenaiEx User Guide","doc":"# OpenaiEx User Guide\n\n```elixir\nMix.install([\n  {:openai_ex, \"~> 0.4.1\"},\n  # {:openai_ex, path: Path.join(__DIR__, \"..\")},\n  {:kino, \"~> 0.11.0\"}\n])\n```","ref":"userguide.html"},{"type":"extras","title":"Introduction - OpenaiEx User Guide","doc":"`OpenaiEx` is an Elixir library that provides a community-maintained OpenAI API client especially for Livebook development.\n\nAt this point, all API endpoints and features (as of Nov 11, 2023) are supported, including the **Assistants API Beta**, the **tools support** in chat completions, and the **streaming version** of the completion and chat completion endpoints.\n\nThere are some differences compared to other elixir openai wrappers.\n\n* I tried to faithfully mirror the naming/structure of the official python api. For example, content that is already in memory can be uploaded as part of a request, it doesn't have to be read from a file at a local path.\n* I was developing for a livebook use-case, so I don't have any config, only environment variables.\n* Streaming API versions are fully supported.\n\nTo learn how to use OpenaiEx, you can refer to the relevant parts of the official OpenAI API reference documentation, which we link to throughout this document.\n\nThis file is an executable Livebook, which means you can interactively run and modify the code samples provided. We encourage you to open it in Livebook and try out the code for yourself!","ref":"userguide.html#introduction"},{"type":"extras","title":"Installation - OpenaiEx User Guide","doc":"You can install OpenaiEx using Mix:\n\n#","ref":"userguide.html#installation"},{"type":"extras","title":"In Livebook - OpenaiEx User Guide","doc":"Add the following code to the first connection cell:\n\n \n\n```elixir\nMix.install(\n  [\n    {:openai_ex, \"~> 0.4.1\"}\n  ]\n)\n```\n\n#","ref":"userguide.html#in-livebook"},{"type":"extras","title":"In a Mix Project - OpenaiEx User Guide","doc":"Add the following to your mix.exs file:\n\n \n\n```elixir\ndef deps do\n  [\n    {:openai_ex, \"~> 0.4.1\"}\n  ]\nend\n```","ref":"userguide.html#in-a-mix-project"},{"type":"extras","title":"Authentication - OpenaiEx User Guide","doc":"To authenticate with the OpenAI API, you will need an API key. We recommend storing your API key in an environment variable. Since we are using Livebook, we can store this and other environment variables as [Livebook Hub Secrets](https://news.livebook.dev/hubs-and-secret-management---launch-week-1---day-3-3tMaJ2).\n\n```elixir\napikey = System.fetch_env!(\"LB_OPENAI_API_KEY\")\nopenai = OpenaiEx.new(apikey)\n```\n\nYou can also specify an organization if you are a member of more than one:\n\n```elixir\n# organization = System.fetch_env!(\"LB_OPENAI_ORGANIZATION\")\n# openai = OpenaiEx.new(apikey, organization)\n```\n\nFor more information on authentication, see the [OpenAI API Authentication reference](https://platform.openai.com/docs/api-reference/authentication).","ref":"userguide.html#authentication"},{"type":"extras","title":"Model - OpenaiEx User Guide","doc":"#","ref":"userguide.html#model"},{"type":"extras","title":"List Models - OpenaiEx User Guide","doc":"To list all available models, use the [`Model.list()`](https://platform.openai.com/docs/api-reference/models/list) function:\n\n```elixir\nalias OpenaiEx.Model\n\nopenai |> Model.list()\n```\n\n#","ref":"userguide.html#list-models"},{"type":"extras","title":"Retrieve Models - OpenaiEx User Guide","doc":"To retrieve information about a specific model, use the [`Model.retrieve()`](https://platform.openai.com/docs/api-reference/models/retrieve) function:\n\n```elixir\nopenai |> Model.retrieve(\"text-davinci-003\")\n```\n\nFor more information on using models, see the [OpenAI API Models reference](https://platform.openai.com/docs/api-reference/models).","ref":"userguide.html#retrieve-models"},{"type":"extras","title":"Completion - OpenaiEx User Guide","doc":"To generate a completion, you first need to define a completion request structure using the `Completion.new()` function. This function takes several parameters, such as the model ID, the prompt, the maximum number of tokens, etc.\n\n```elixir\nalias OpenaiEx.Completion\n\ncompletion_req =\n  Completion.new(\n    model: \"text-davinci-003\",\n    prompt:\n      \"Give me some background on the elixir language. Why was it created? What is it used for? What distinguishes it from other languages? How popular is it?\",\n    max_tokens: 500,\n    temperature: 0\n  )\n```\n\nOnce you have defined the completion request structure, you can generate a completion using the [`Completion.create()`](https://platform.openai.com/docs/api-reference/completions/create) function:\n\n```elixir\ncomp_response = openai |> Completion.create(completion_req)\n```\n\nYou can also call the endpoint and have it return a stream. This returns the result as a series of tokens, which have to be put together in code.\n\nTo use the stream option, call the `Completion.create()` function with `stream: true`\n\n```elixir\ncompletion_stream = openai |> Completion.create(completion_req, stream: true)\n\ncompletion_stream |> Stream.flat_map(& &1) |> Enum.each(fn x -> IO.puts(inspect(x)) end)\n```\n\nFor an example of how to programmatically work with this stream, check out the [Completions Bot livebook](https://hexdocs.pm/openai_ex/completions.html) which builds a ChatBot UI using the Completion API (with and without streaming).\n\nFor more information on generating completions, see the [OpenAI API Completions reference](https://platform.openai.com/docs/api-reference/completions).","ref":"userguide.html#completion"},{"type":"extras","title":"Chat Completion - OpenaiEx User Guide","doc":"To generate a chat completion, you need to define a chat completion request structure using the `ChatCompletion.new()` function. This function takes several parameters, such as the model ID and a list of chat messages. We have a module `ChatMessage` which helps create messages in the [chat format](https://platform.openai.com/docs/guides/chat/introduction).\n\n```elixir\nalias OpenaiEx.ChatCompletion\nalias OpenaiEx.ChatMessage\nalias OpenaiEx.MsgContent\n\nchat_req =\n  ChatCompletion.new(\n    model: \"gpt-3.5-turbo\",\n    messages: [\n      ChatMessage.user(\n        \"Give me some background on the elixir language. Why was it created? What is it used for? What distinguishes it from other languages? How popular is it?\"\n      )\n    ]\n  )\n```\n\nYou are able to pass images to the API by creating a message.\n\n```elixir\nChatMessage.user(\n  MsgContent.image_url(\n    \"https://raw.githubusercontent.com/restlessronin/openai_ex/main/assets/images/starmask.png\"\n  )\n)\n```\n\nYou can generate a chat completion using the [`ChatCompletion.create()`](https://platform.openai.com/docs/api-reference/chat/completions/create) function:\n\n```elixir\nchat_response = openai |> ChatCompletion.create(chat_req)\n```\n\nYou can also call the endpoint and have it stream the response. This returns the result as a series of tokens, which have to be put together in code.\n\nTo use the stream option, call the `ChatCompletion.create()` function with `stream: true`\n\n```elixir\nchat_stream = openai |> ChatCompletion.create(chat_req, stream: true)\n\nchat_stream |> Stream.flat_map(& &1) |> Enum.each(fn x -> IO.puts(inspect(x)) end)\n```\n\nFor a more in-depth example of `ChatCompletion`, check out the [Deeplearning.AI OrderBot Livebook](https://hexdocs.pm/openai_ex/dlai_orderbot.html).\n\nFor a detailed example of the use of the streaming `ChatCompletion` API, check out [Streaming Orderbot](https://hexdocs.pm/openai_ex/streaming_orderbot.html), the streaming equivalent of the prior example.\n\nFor more information on generating chat completions, see the [OpenAI API Chat Completions reference](https://platform.openai.com/docs/api-reference/chat).\n\n#","ref":"userguide.html#chat-completion"},{"type":"extras","title":"Function(Tool) Calling - OpenaiEx User Guide","doc":"In OpenAI's `ChatCompletion` endpoint, you can use the function calling feature to call a custom function and pass its result as part of the conversation. Here's an example of how to use the function calling feature:\n\nFirst, we set up the function specification and completion request. The function specification defines the name, description, and parameters of the function we want to call. In this example, we define a function called `get_current_weather` that takes a `location` parameter and an optional `unit` parameter. The completion request includes the function specification, the conversation history, and the model we want to use.\n\n```elixir\ntool_spec =\n  Jason.decode!(\"\"\"\n    {\"type\": \"function\",\n     \"function\": {\n        \"name\": \"get_current_weather\",\n        \"description\": \"Get the current weather in a given location\",\n        \"parameters\": {\n          \"type\": \"object\",\n          \"properties\": {\n            \"location\": {\n              \"type\": \"string\",\n              \"description\": \"The city and state, e.g. San Francisco, CA\"\n            },\n            \"unit\": {\n              \"type\": \"string\",\n              \"enum\": [\"celsius\", \"fahrenheit\"]\n            }\n          },\n          \"required\": [\"location\"]\n        }\n      }\n    }\n  \"\"\")\n\nrev_msgs = [\n  ChatMessage.user(\"What's the weather like in Boston today?\")\n]\n\nfn_req =\n  ChatCompletion.new(\n    model: \"gpt-3.5-turbo\",\n    messages: rev_msgs |> Enum.reverse(),\n    tools: [tool_spec],\n    tool_choice: \"auto\"\n  )\n```\n\nNext, we call the OpenAI endpoint to get a response that includes the function call.\n\n```elixir\nfn_response = openai |> ChatCompletion.create(fn_req)\n```\n\nWe extract the function call from the response and call the appropriate function with the given parameters. In this example, we define a map of functions that maps function names to their implementations. We then use the function name and arguments from the function call to look up the appropriate function and call it with the given parameters.\n\n```elixir\nfn_message = fn_response[\"choices\"] |> Enum.at(0) |> Map.get(\"message\")\ntool_call = fn_message |> Map.get(\"tool_calls\") |> List.first()\ntool_id = tool_call |> Map.get(\"id\")\nfn_call = tool_call |> Map.get(\"function\")\n\nfunctions = %{\n  \"get_current_weather\" => fn location, unit ->\n    %{\n      \"location\" => location,\n      \"temperature\" => \"72\",\n      \"unit\" => unit,\n      \"forecast\" => [\"sunny\", \"windy\"]\n    }\n    |> Jason.encode!()\n  end\n}\n\nfn_name = fn_call[\"name\"]\nfn_args = fn_call[\"arguments\"] |> Jason.decode!()\n\nlocation = fn_args[\"location\"]\nunit = unless is_nil(fn_args[\"unit\"]), do: fn_args[\"unit\"], else: \"fahrenheit\"\n\nfn_value = functions[fn_name].(location, unit)\n```\n\nWe then pass the returned value back to the ChatCompletion endpoint with the conversation history to that point to get the final response.\n\n```elixir\nlatest_msgs = [ChatMessage.tool(tool_id, fn_name, fn_value) | [fn_message | rev_msgs]]\n\nfn_req_2 =\n  ChatCompletion.new(\n    model: \"gpt-3.5-turbo\",\n    messages: latest_msgs |> Enum.reverse()\n  )\n\nfn_response_2 = openai |> ChatCompletion.create(fn_req_2)\n```\n\nThe final response includes the result of the function call integrated into the conversation.","ref":"userguide.html#function-tool-calling"},{"type":"extras","title":"Image - OpenaiEx User Guide","doc":"#","ref":"userguide.html#image"},{"type":"extras","title":"Generate Image - OpenaiEx User Guide","doc":"We define the image creation request structure using the `Image.new` function\n\n```elixir\nalias OpenaiEx.Image\n\nimg_req = Image.new(prompt: \"An adorable baby sea otter\", size: \"256x256\", n: 1)\n```\n\nThen call the [`Image.create()`](https://platform.openai.com/docs/api-reference/images/create) function to generate the images.\n\n```elixir\nimg_response = openai |> Image.create(img_req)\n```\n\nFor more information on generating images, see the [OpenAI API Image reference](https://platform.openai.com/docs/api-reference/images).\n\n##","ref":"userguide.html#generate-image"},{"type":"extras","title":"Fetch the generated images - OpenaiEx User Guide","doc":"With the information in the image response, we can fetch the images from their URLs\n\n```elixir\nfetch_blob = fn url ->\n  Finch.build(:get, url) |> Finch.request!(OpenaiEx.Finch) |> Map.get(:body)\nend\n```\n\n```elixir\nfetched_images = img_response[\"data\"] |> Enum.map(fn i -> i[\"url\"] |> fetch_blob.() end)\n```\n\n##","ref":"userguide.html#fetch-the-generated-images"},{"type":"extras","title":"View the generated images - OpenaiEx User Guide","doc":"Finally, we can render the images using Kino\n\n```elixir\nfetched_images\n|> Enum.map(fn r -> r |> Kino.Image.new(\"image/png\") |> Kino.render() end)\n```\n\n```elixir\nimg_to_expmt = fetched_images |> List.first()\n```\n\n#","ref":"userguide.html#view-the-generated-images"},{"type":"extras","title":"Edit Image - OpenaiEx User Guide","doc":"We define an image edit request structure using the `Image.Edit.new()` function. This function requires an image and a mask. For the image, we will use the one that we received. Let's load the mask from a URL.\n\n```elixir\n# if you're having problems downloading raw github content, you may need to manually set your DNS server to \"8.8.8.8\" (google)\nstar_mask =\n  fetch_blob.(\n    \"https://raw.githubusercontent.com/restlessronin/openai_ex/main/assets/images/starmask.png\"\n  )\n\n# star_mask = OpenaiEx.new_file(path: Path.join(__DIR__, \"../assets/images/starmask.png\"))\n```\n\nSet up the image edit request with image, mask and prompt.\n\n```elixir\nimg_edit_req =\n  Image.Edit.new(\n    image: img_to_expmt,\n    mask: star_mask,\n    size: \"256x256\",\n    prompt: \"Image shows a smiling Otter\"\n  )\n```\n\nWe then call the [`Image.create_edit()`]() function\n\n```elixir\nimg_edit_response = openai |> Image.create_edit(img_edit_req)\n```\n\nand view the result\n\n```elixir\nimg_edit_response[\"data\"]\n|> Enum.map(fn i -> i[\"url\"] |> fetch_blob.() |> Kino.Image.new(\"image/png\") |> Kino.render() end)\n```\n\n#","ref":"userguide.html#edit-image"},{"type":"extras","title":"Image Variations - OpenaiEx User Guide","doc":"We define an image variation request structure using the `Image.Variation.new()` function. This function requires an image.\n\n```elixir\nimg_var_req = Image.Variation.new(image: img_to_expmt, size: \"256x256\")\n```\n\nThen call the [`Image.create_variation()`](https://platform.openai.com/docs/api-reference/images/create-variation) function to generate the images.\n\n \n\n###\n\n```elixir\nimg_var_response = openai |> Image.create_variation(img_var_req)\n```\n\n```elixir\nimg_var_response[\"data\"]\n|> Enum.map(fn i -> i[\"url\"] |> fetch_blob.() |> Kino.Image.new(\"image/png\") |> Kino.render() end)\n```\n\nFor more information on images variations, see the [OpenAI API Image Variations reference](https://platform.openai.com/docs/api-reference/images/create-variation).","ref":"userguide.html#image-variations"},{"type":"extras","title":"Embedding - OpenaiEx User Guide","doc":"Define the embedding request structure using `Embedding.new`.\n\n```elixir\nalias OpenaiEx.Embedding\n\nemb_req =\n  Embedding.new(\n    model: \"text-embedding-ada-002\",\n    input: \"The food was delicious and the waiter...\"\n  )\n```\n\nThen call the [`Embedding.create()`]() function.\n\n```elixir\nemb_response = openai |> Embedding.create(emb_req)\n```\n\nFor more information on generating embeddings, see the [OpenAI API Embedding reference](https://platform.openai.com/docs/api-reference/embeddings/create)","ref":"userguide.html#embedding"},{"type":"extras","title":"Audio - OpenaiEx User Guide","doc":"#","ref":"userguide.html#audio"},{"type":"extras","title":"Transcription - OpenaiEx User Guide","doc":"To define an Audio request structure, we need to create a file parameter using `Audio.File.new()`.\n\n```elixir\nalias OpenaiEx.Audio\n\n# if you're having problems downloading raw github content, you may need to manually set your DNS server to \"8.8.8.8\" (google)\naudio_url = \"https://raw.githubusercontent.com/restlessronin/openai_ex/main/assets/transcribe.mp3\"\naudio_file = OpenaiEx.new_file(name: audio_url, content: fetch_blob.(audio_url))\n\n# audio_file = OpenaiEx.new_file(path: Path.join(__DIR__, \"../assets/transcribe.mp3\"))\n```\n\nThe file parameter is used to create the Audio request structure\n\n```elixir\naudio_req = Audio.new(file: audio_file, model: \"whisper-1\")\n```\n\nWe then call the [`Audio.transcribe()`](https://platform.openai.com/docs/api-reference/audio/create) function to create a transcription.\n\n```elixir\naudio_response = openai |> Audio.transcribe(audio_req)\n```\n\n#","ref":"userguide.html#transcription"},{"type":"extras","title":"Translation - OpenaiEx User Guide","doc":"The translation call uses practically the same request structure, but calls the `Audio.translate()` endpoint\n\nFor more information on the audio endpoints see the [Openai API Audio Reference](https://platform.openai.com/docs/api-reference/audio)","ref":"userguide.html#translation"},{"type":"extras","title":"File - OpenaiEx User Guide","doc":"#","ref":"userguide.html#file"},{"type":"extras","title":"List files - OpenaiEx User Guide","doc":"To request all files that belong to the user organization, call the [`File.list()`](https://platform.openai.com/docs/api-reference/files/list) function\n\n```elixir\nalias OpenaiEx.File\n\nopenai |> File.list()\n```\n\n#","ref":"userguide.html#list-files"},{"type":"extras","title":"Upload files - OpenaiEx User Guide","doc":"To upload a file, we need to create a file parameter, and then the upload request\n\n```elixir\n# if you're having problems downloading raw github content, you may need to manually set your DNS server to \"8.8.8.8\" (google)\nftf_url = \"https://raw.githubusercontent.com/restlessronin/openai_ex/main/assets/fine-tune.jsonl\"\nfine_tune_file = OpenaiEx.new_file(name: ftf_url, content: fetch_blob.(ftf_url))\n\n# fine_tune_file = OpenaiEx.new_file(path: Path.join(__DIR__, \"../assets/fine-tune.jsonl\"))\n\nupload_req = File.new_upload(file: fine_tune_file, purpose: \"fine-tune\")\n```\n\nThen we call the [`File.create()`](https://platform.openai.com/docs/api-reference/files/upload) function to upload the file\n\n```elixir\nupload_res = openai |> File.create(upload_req)\n```\n\nWe can verify that the file has been uploaded by calling\n\n```elixir\nopenai |> File.list()\n```\n\nWe grab the file id from the previous response value to use in the following samples\n\n```elixir\nfile_id = upload_res[\"id\"]\n```\n\n#","ref":"userguide.html#upload-files"},{"type":"extras","title":"Retrieve files - OpenaiEx User Guide","doc":"In order to retrieve meta information on a file, we simply call the [`File.retrieve()`]() function with the given id\n\n```elixir\nopenai |> File.retrieve(file_id)\n```\n\n#","ref":"userguide.html#retrieve-files"},{"type":"extras","title":"Retrieve file content - OpenaiEx User Guide","doc":"Similarly to download the file contents, we call [`File.download()`]()\n\n```elixir\nopenai |> File.download(file_id)\n```\n\n#","ref":"userguide.html#retrieve-file-content"},{"type":"extras","title":"Delete file - OpenaiEx User Guide","doc":"Finally, we can delete the file by calling [`File.delete()`](https://platform.openai.com/docs/api-reference/files/delete)\n\n```elixir\nopenai |> File.delete(file_id)\n```\n\nVerify that the file has been deleted by listing files again\n\n```elixir\nopenai |> File.list()\n```","ref":"userguide.html#delete-file"},{"type":"extras","title":"FineTuning Job - OpenaiEx User Guide","doc":"To run a fine-tuning job, we minimally need a training file. We will re-run the file creation request above.\n\n```elixir\nupload_res = openai |> File.create(upload_req)\n```\n\nNext we call `FineTuning.Job.new()` to create a new request structure\n\n```elixir\nalias OpenaiEx.FineTuning\n\nft_req = FineTuning.Job.new(model: \"davinci-002\", training_file: upload_res[\"id\"])\n```\n\nTo begin the fine tune, we call the [`FineTune.create()`](https://platform.openai.com/docs/api-reference/fine-tunes/create) function\n\n```elixir\nft_res = openai |> FineTuning.Job.create(ft_req)\n```\n\nWe can list all fine tunes by calling [`FineTune.list()`](https://platform.openai.com/docs/api-reference/fine-tunes/list)\n\n```elixir\nopenai |> FineTuning.Job.list()\n```\n\nThe function [`FineTune.retrieve()`](https://platform.openai.com/docs/api-reference/fine-tunes/retrieve) gets the details of a particular fine tune.\n\n```elixir\nft_id = ft_res[\"id\"]\nopenai |> FineTuning.Job.retrieve(fine_tuning_job_id: ft_id)\n```\n\nand [`FineTune.list_events()`](https://platform.openai.com/docs/api-reference/fine-tunes/events) can be called to get the events\n\n```elixir\nopenai |> FineTuning.Job.list_events(fine_tuning_job_id: ft_id)\n```\n\nTo cancel a Fine Tune job, call [`FineTune.cancel()`](https://platform.openai.com/docs/api-reference/fine-tunes/cancel)\n\n```elixir\nopenai |> FineTuning.Job.cancel(fine_tuning_job_id: ft_id)\n```\n\nA fine tuned model can be deleted by calling the [`Model.delete()`](https://platform.openai.com/docs/api-reference/fine-tunes/delete-model)\n\n```elixir\nft_model = ft_res[\"fine_tuned_model\"]\n\nunless is_nil(ft_model) do\n  openai |> Model.delete(ft_model)\nend\n```\n\nFor more information on the fine tune endpoints see the [Openai API Moderation Reference](https://platform.openai.com/docs/api-reference/fine-tunes)","ref":"userguide.html#finetuning-job"},{"type":"extras","title":"Moderation - OpenaiEx User Guide","doc":"We use the moderation API by calling `Moderation.new()` to create a new request\n\n```elixir\nalias OpenaiEx.Moderation\n\nmod_req = Moderation.new(input: \"I want to kill people\")\n```\n\nThe call the function [`Moderation.create()`](https://platform.openai.com/docs/api-reference/moderations/create)\n\n```elixir\nmod_res = openai |> Moderation.create(mod_req)\n```\n\nFor more information on the moderation endpoints see the [Openai API Moderation Reference](https://platform.openai.com/docs/api-reference/moderations)","ref":"userguide.html#moderation"},{"type":"extras","title":"Assistant - OpenaiEx User Guide","doc":"```elixir\nalias OpenaiEx.Beta.Assistant\n```\n\n#","ref":"userguide.html#assistant"},{"type":"extras","title":"Create Assistant - OpenaiEx User Guide","doc":"To create an assistant with model and instructions, call the [`Assistant.create()`](https://platform.openai.com/docs/api-reference/assistants/createAssistant) function.\n\nFirst, we setup the create request parameters. This request sets up an Assistant with a code interpreter tool.\n\n```elixir\nmath_assistant_req =\n  Assistant.new(\n    instructions:\n      \"You are a personal math tutor. When asked a question, write and run Python code to answer the question.\",\n    name: \"Math Tutor\",\n    tools: [%{type: \"code_interpreter\"}],\n    model: \"gpt-4\"\n  )\n```\n\nThen we call the create function\n\n```elixir\nasst = openai |> Assistant.create(math_assistant_req)\n```\n\n#","ref":"userguide.html#create-assistant"},{"type":"extras","title":"Retrieve Assistant - OpenaiEx User Guide","doc":"Extract the id field for the assistant\n\n```elixir\nassistant_id = asst[\"id\"]\n```\n\nwhich can then be used to retrieve the Assistant fields, using the [`Assistant.retrieve()`](https://platform.openai.com/docs/api-reference/assistants/getAssistant) function.\n\n```elixir\nopenai |> Assistant.retrieve(assistant_id)\n```\n\n#","ref":"userguide.html#retrieve-assistant"},{"type":"extras","title":"Modify Assistant - OpenaiEx User Guide","doc":"Once created, an assistant can be modified using the [`Assistant.update()`](https://platform.openai.com/docs/api-reference/assistants/modifyAssistant) function.\n\nNow we will show an example assistant request using the retrieval tool with a set of files. First we set up the files (in this case a sample HR document) by uploading using the `File` API.\n\n```elixir\nalias OpenaiEx.File\n\nhr_file = OpenaiEx.new_file(path: Path.join(__DIR__, \"../assets/cyberdyne.txt\"))\nhr_upload_req = File.new_upload(file: hr_file, purpose: \"assistants\")\nhr_upload_res = openai |> File.create(hr_upload_req)\n```\n\n```elixir\nfile_id = hr_upload_res[\"id\"]\n```\n\nNext we create the update request\n\n```elixir\nhr_assistant_req =\n  Assistant.new(\n    instructions:\n      \"You are an HR bot, and you have access to files to answer employee questions about company policies. Always respond with info from one of the files.\",\n    name: \"HR Helper\",\n    tools: [%{type: \"retrieval\"}],\n    model: \"gpt-3.5-turbo-1106\",\n    file_ids: [file_id]\n  )\n```\n\nFinally we call the endpoint to modify the `Assistant`\n\n```elixir\nasst = openai |> Assistant.update(assistant_id, hr_assistant_req)\n```\n\n#","ref":"userguide.html#modify-assistant"},{"type":"extras","title":"Delete Assistant - OpenaiEx User Guide","doc":"Finally we can delete assistants using the [`Assistant.delete()`](https://platform.openai.com/docs/api-reference/assistants/deleteAssistant) function\n\n```elixir\nopenai |> Assistant.delete(assistant_id)\n```\n\n#","ref":"userguide.html#delete-assistant"},{"type":"extras","title":"List Assistants - OpenaiEx User Guide","doc":"We use [`Assistant.list()`](https://platform.openai.com/docs/api-reference/assistants/listAssistants) to get a list of assistants\n\n```elixir\nassts = openai |> Assistant.list()\n```\n\n#","ref":"userguide.html#list-assistants"},{"type":"extras","title":"Create Assistant File - OpenaiEx User Guide","doc":"Use [`Assistants.File.create()`](https://platform.openai.com/docs/api-reference/assistants/createAssistantFile) to attach a file to an assistant.\n\nLet us re-create the first assistant above\n\n```elixir\nmath_asst = openai |> Assistant.create(math_assistant_req)\n```\n\nNow we can attach the file that we used earlier to this new assistant.\n\n```elixir\nmath_assistant_id = math_asst[\"id\"]\nasst_f = Assistant.File.new(assistant_id: math_assistant_id, file_id: file_id)\nasst_file = openai |> Assistant.File.create(asst_f)\n```\n\nLet's retrieve the assistant to see if it was updated with the file id  (check `file_ids` field value).\n\n```elixir\nopenai |> Assistant.retrieve(math_assistant_id)\n```\n\n#","ref":"userguide.html#create-assistant-file"},{"type":"extras","title":"Retreive Assistant File - OpenaiEx User Guide","doc":"We can retrieve an assistant file by using [`Assistants.File.retrieve()`](https://platform.openai.com/docs/api-reference/assistants/getAssistantFile)\n\n```elixir\nopenai |> Assistant.File.retrieve(asst_f)\n```\n\n#","ref":"userguide.html#retreive-assistant-file"},{"type":"extras","title":"Delete Assistant File - OpenaiEx User Guide","doc":"[`Assistant.File.delete()`] can be used to detach a file from the assistant.\n\n```elixir\nopenai |> Assistant.File.delete(asst_f)\n```\n\nVerify detach by retrieving the assistant again (check `file_ids` field value)\n\n```elixir\nopenai |> Assistant.retrieve(math_assistant_id)\n```\n\n#","ref":"userguide.html#delete-assistant-file"},{"type":"extras","title":"List Assistant Files - OpenaiEx User Guide","doc":"We can list all files attached to an assistant with [`Assistant.File.list()`](https://platform.openai.com/docs/api-reference/assistants/listAssistantFiles)\n\n```elixir\nlist_req = Assistant.File.new_list(assistant_id: math_assistant_id)\n\nopenai |> Assistant.File.list(list_req)\n```","ref":"userguide.html#list-assistant-files"},{"type":"extras","title":"Thread - OpenaiEx User Guide","doc":"```elixir\nalias OpenaiEx.Beta.Thread\n```\n\n#","ref":"userguide.html#thread"},{"type":"extras","title":"Create thread - OpenaiEx User Guide","doc":"Use the [`Thread.create()`] function to create threads. A thread can be created empty or with messages.\n\n```elixir\nalias OpenaiEx.ChatMessage\n\nempty_thread = openai |> Thread.create()\n\nmsg_hr = ChatMessage.user(\"What company do we work at?\", [file_id])\nmsg_ai = ChatMessage.user(\"How does AI work? Explain it in simple terms.\")\n\nthrd_req = Thread.new(messages: [msg_hr, msg_ai])\n\nthread = openai |> Thread.create(thrd_req)\n```\n\n#","ref":"userguide.html#create-thread"},{"type":"extras","title":"Retrieve thread - OpenaiEx User Guide","doc":"[`Thread.retrieve()`](https://platform.openai.com/docs/api-reference/threads/getThread) can be used to get the thread parameters given the id.\n\n```elixir\nthread_id = thread[\"id\"]\nopenai |> Thread.retrieve(thread_id)\n```\n\n#","ref":"userguide.html#retrieve-thread"},{"type":"extras","title":"Modify thread - OpenaiEx User Guide","doc":"The metadata for a thread can be modified using [`Thread.update()`](https://platform.openai.com/docs/api-reference/threads/modifyThread)\n\n```elixir\nopenai |> Thread.update(thread_id, %{metadata: %{modified: \"true\", user: \"abc123\"}})\n```\n\n#","ref":"userguide.html#modify-thread"},{"type":"extras","title":"Delete thread - OpenaiEx User Guide","doc":"Use [`Thread.delete()`](https://platform.openai.com/docs/api-reference/threads/deleteThread) to delete a thread\n\n```elixir\nopenai |> Thread.delete(thread_id)\n```\n\nVerify deletion\n\n```elixir\nopenai |> Thread.retrieve(thread_id)\n```","ref":"userguide.html#delete-thread"},{"type":"extras","title":"Messages - OpenaiEx User Guide","doc":"```elixir\nalias OpenaiEx.Beta.Thread.Message\n```\n\n#","ref":"userguide.html#messages"},{"type":"extras","title":"Create message - OpenaiEx User Guide","doc":"You can create a single message for a thread using [`Message.create()`](https://platform.openai.com/docs/api-reference/messages/createMessage)\n\n```elixir\nthread_id = empty_thread[\"id\"]\n\nmessage = openai |> Message.create(thread_id, msg_hr)\n```\n\n#","ref":"userguide.html#create-message"},{"type":"extras","title":"Retrieve message - OpenaiEx User Guide","doc":"Use [`Message.retrieve()`] to retrieve a message\n\n```elixir\nmessage_id = message[\"id\"]\nopenai |> Message.retrieve(%{thread_id: thread_id, message_id: message_id})\n```\n\n#","ref":"userguide.html#retrieve-message"},{"type":"extras","title":"Modify message - OpenaiEx User Guide","doc":"The metadata for a message can be modified by [`Message.update()`]\n\n```elixir\nmetadata = %{modified: \"true\", user: \"abc123\"}\nupd_msg_req = Message.new(thread_id: thread_id, message_id: message_id, metadata: metadata)\n\nmessage = openai |> Message.update(upd_msg_req)\n```\n\n#","ref":"userguide.html#modify-message"},{"type":"extras","title":"List messages - OpenaiEx User Guide","doc":"Use [`Message.list()`] to get all the messages for a given thread\n\n```elixir\nopenai |> Message.list(thread_id)\n```\n\n#","ref":"userguide.html#list-messages"},{"type":"extras","title":"Retrieve message file - OpenaiEx User Guide","doc":"Retrieve a message file using [`Message.File.retrieve()`]\n\n```elixir\nopenai |> Message.File.retrieve(%{thread_id: thread_id, message_id: message_id, file_id: file_id})\n```\n\n#","ref":"userguide.html#retrieve-message-file"},{"type":"extras","title":"List message files - OpenaiEx User Guide","doc":"You can list all message files using [`Message.File.list()`]\n\n```elixir\nopenai |> Message.File.list(%{thread_id: thread_id, message_id: message_id})\n```","ref":"userguide.html#list-message-files"},{"type":"extras","title":"Runs - OpenaiEx User Guide","doc":"```elixir\nalias OpenaiEx.Beta.Thread.Run\n```\n\n#","ref":"userguide.html#runs"},{"type":"extras","title":"Create run - OpenaiEx User Guide","doc":"A run represents an execution on a thread. Use to [`Run.create()`](https://platform.openai.com/docs/api-reference/runs/createRun) with an assistant on a thread\n\n```elixir\nrun_req = Run.new(thread_id: thread_id, assistant_id: math_assistant_id)\n\nrun = openai |> Run.create(run_req)\n```\n\n#","ref":"userguide.html#create-run"},{"type":"extras","title":"Retrieve run - OpenaiEx User Guide","doc":"Retrieve a run using [`Run.retrieve()`](https://platform.openai.com/docs/api-reference/runs/getRun)\n\n```elixir\nrun_id = run[\"id\"]\nopenai |> Run.retrieve(%{thread_id: thread_id, run_id: run_id})\n```\n\n#","ref":"userguide.html#retrieve-run"},{"type":"extras","title":"Modify run - OpenaiEx User Guide","doc":"The run metadata can be modified using the [`Run.update()`](https://platform.openai.com/docs/api-reference/runs/modifyRun) function\n\n```elixir\nopenai\n|> Run.update(%{\n  thread_id: thread_id,\n  run_id: run_id,\n  metadata: %{user_id: \"user_zmVY6FvuBDDwIqM4KgH\"}\n})\n```\n\n#","ref":"userguide.html#modify-run"},{"type":"extras","title":"List runs - OpenaiEx User Guide","doc":"List the runs belonging to a thread using [`Run.list()`](https://platform.openai.com/docs/api-reference/runs/listRuns)\n\n```elixir\nopenai |> Run.list(thread_id)\n```\n\n#","ref":"userguide.html#list-runs"},{"type":"extras","title":"Submit tool outputs to a run - OpenaiEx User Guide","doc":"When a run has the `status`: \"requires_action\" and `required_action.type` is `submit_tool_outputs`, the [`Run.submit_tool_outputs()`](https://platform.openai.com/docs/api-reference/runs/submitToolOutputs) can be used to submit the outputs from the tool calls once they're all completed. All outputs must be submitted in a single request.\n\n```elixir\nopenai\n|> Run.submit_tool_outputs(%{\n  thread_id: thread_id,\n  run_id: run_id,\n  tool_outputs: [%{tool_call_id: \"foobar\", output: \"28C\"}]\n})\n```\n\n#","ref":"userguide.html#submit-tool-outputs-to-a-run"},{"type":"extras","title":"Cancel a run - OpenaiEx User Guide","doc":"You can cancel a run `in_progress` using [`Run.cancel()`](https://platform.openai.com/docs/api-reference/runs/cancelRun)\n\n```elixir\nopenai |> Run.cancel(%{thread_id: thread_id, run_id: run_id})\n```\n\n#","ref":"userguide.html#cancel-a-run"},{"type":"extras","title":"Create thread and run - OpenaiEx User Guide","doc":"Use [`Run.create_and_run()`](https://platform.openai.com/docs/api-reference/runs/createThreadAndRun) to create a thread and run.\n\n```elixir\n\n```","ref":"userguide.html#create-thread-and-run"},{"type":"extras","title":"Streaming Orderbot","doc":"# Streaming Orderbot\n\n```elixir\nMix.install([\n  {:openai_ex, \"~> 0.4.1\"},\n  {:kino, \"~> 0.11.0\"}\n])\n\nalias OpenaiEx\nalias OpenaiEx.ChatCompletion\nalias OpenaiEx.ChatMessage\n```","ref":"streaming_orderbot.html"},{"type":"extras","title":"Setup - Streaming Orderbot","doc":"This notebook creates an Orderbot, similar to the one in [Deeplearning.AI Orderbot](https://hexdocs.pm/openai_ex/0.4.1/dlai_orderbot.html), but using the streaming version of the Chat Completion API.\n\n```elixir\nopenai = System.fetch_env!(\"LB_OPENAI_API_KEY\") |> OpenaiEx.new()\n```\n\n```elixir\ndefmodule OpenaiEx.Notebooks.StreamingOrderbot do\n  alias OpenaiEx\n  alias OpenaiEx.ChatCompletion\n\n  def create_chat_req(args = [_ | _]) do\n    args\n    |> Enum.into(%{\n      model: \"gpt-3.5-turbo\",\n      temperature: 0\n    })\n    |> ChatCompletion.new()\n  end\n\n  def get_completion_stream(openai = %OpenaiEx{}, cc_req = %{}) do\n    openai\n    |> ChatCompletion.create(cc_req, stream: true)\n    |> Stream.flat_map(& &1)\n    |> Stream.map(fn %{data: d} -> d |> Map.get(\"choices\") |> Enum.at(0) |> Map.get(\"delta\") end)\n    |> Stream.filter(fn map -> map |> Map.has_key?(\"content\") end)\n    |> Stream.map(fn map -> map |> Map.get(\"content\") end)\n  end\n\n  def stream_completion_to_frame(openai = %OpenaiEx{}, messages, frame) do\n    openai\n    |> get_completion_stream(create_chat_req(messages: messages))\n    |> Enum.reduce(\"\", fn token, text ->\n      next = text   token\n      Kino.Frame.render(frame, Kino.Text.new(next))\n      next\n    end)\n  end\n\n  def create_orderbot(openai = %OpenaiEx{}, context) do\n    chat_frame = Kino.Frame.new()\n    last_frame = Kino.Frame.new()\n    inputs = [prompt: Kino.Input.textarea(\"You\")]\n    form = Kino.Control.form(inputs, submit: \"Send\", reset_on_submit: [:prompt])\n    Kino.Frame.render(chat_frame, Kino.Markdown.new(\"#","ref":"streaming_orderbot.html#setup"},{"type":"extras","title":"Orderbot Chat\")) - Streaming Orderbot","doc":"Kino.Layout.grid([chat_frame, last_frame, form], boxed: true, gap: 16) |> Kino.render()\n\n    bot_says = openai |> stream_completion_to_frame(context, last_frame)\n\n    Kino.listen(\n      form,\n      context ++ [ChatMessage.assistant(bot_says)],\n      fn %{data: %{prompt: you_say}}, history ->\n        Kino.Frame.render(last_frame, Kino.Text.new(\"\"))\n        Kino.Frame.append(chat_frame, Kino.Text.new(List.last(history).content))\n        Kino.Frame.append(chat_frame, Kino.Markdown.new(\"**You** #{you_say}\"))\n\n        bot_says =\n          openai |> stream_completion_to_frame(history ++ [ChatMessage.user(you_say)], last_frame)\n\n        {:cont, history ++ [ChatMessage.user(you_say), ChatMessage.assistant(bot_says)]}\n      end\n    )\n  end\nend\n\nalias OpenaiEx.Notebooks.StreamingOrderbot\n```","ref":"streaming_orderbot.html#orderbot-chat"},{"type":"extras","title":"Orderbot - Streaming Orderbot","doc":"```elixir\ncontext = [\n  ChatMessage.system(\"\"\"\n  You are OrderBot, an automated service to collect orders for a pizza restaurant. \\\n  You first greet the customer, then collects the order, \\\n  and then asks if it's a pickup or delivery. \\\n  You wait to collect the entire order, then summarize it and check for a final \\\n  time if the customer wants to add anything else. \\\n  If it's a delivery, you ask for an address. \\\n  Finally you collect the payment.\\\n  Make sure to clarify all options, extras and sizes to uniquely \\\n  identify the item from the menu.\\\n  You respond in a short, very conversational friendly style. \\\n  The menu includes \\\n  pepperoni pizza  12.95, 10.00, 7.00 \\\n  cheese pizza   10.95, 9.25, 6.50 \\\n  eggplant pizza   11.95, 9.75, 6.75 \\\n  fries 4.50, 3.50 \\\n  greek salad 7.25 \\\n  Toppings: \\\n  extra cheese 2.00, \\\n  mushrooms 1.50 \\\n  sausage 3.00 \\\n  canadian bacon 3.50 \\\n  AI sauce 1.50 \\\n  peppers 1.00 \\\n  Drinks: \\\n  coke 3.00, 2.00, 1.00 \\\n  sprite 3.00, 2.00, 1.00 \\\n  bottled water 5.00 \\\n  \"\"\")\n]\n```\n\n```elixir\nopenai |> StreamingOrderbot.create_orderbot(context)\n```","ref":"streaming_orderbot.html#orderbot"},{"type":"extras","title":"Deeplearning.AI Order Bot","doc":"# Deeplearning.AI Order Bot\n\n```elixir\nMix.install([\n  {:openai_ex, \"~> 0.4.1\"},\n  {:kino, \"~> 0.11.0\"}\n])\n\nalias OpenaiEx\nalias OpenaiEx.ChatCompletion\nalias OpenaiEx.ChatMessage\n```","ref":"dlai_orderbot.html"},{"type":"extras","title":"Source - Deeplearning.AI Order Bot","doc":"This notebook is an elixir translation of the python notebook in [Lesson 8](https://learn.deeplearning.ai/chatgpt-prompt-eng/lesson/8/chatbot), of [Deeplearning.AI](https://www.deeplearning.ai/)'s course [ChatGPT Prompt Engineering for Developers](https://www.deeplearning.ai/short-courses/chatgpt-prompt-engineering-for-developers/).","ref":"dlai_orderbot.html#source"},{"type":"extras","title":"Chat Format - Deeplearning.AI Order Bot","doc":"In this notebook, you will explore how you can utilize the chat format to have extended conversations with chatbots personalized or specialized for specific tasks or behaviors.\n\n#","ref":"dlai_orderbot.html#chat-format"},{"type":"extras","title":"Setup - Deeplearning.AI Order Bot","doc":"```elixir\nopenai = System.fetch_env!(\"LB_OPENAI_API_KEY\") |> OpenaiEx.new()\n```\n\n```elixir\ndefmodule OpenaiEx.Notebooks.DlaiOrderbot do\n  alias OpenaiEx\n  alias OpenaiEx.ChatCompletion\n\n  def create_chat_req(args = [_ | _]) do\n    args\n    |> Enum.into(%{\n      model: \"gpt-3.5-turbo\",\n      temperature: 0\n    })\n    |> ChatCompletion.new()\n  end\n\n  def get_completion(openai = %OpenaiEx{}, cc_req = %{}) do\n    openai\n    |> ChatCompletion.create(cc_req)\n    # for debugging\n    #    |> IO.inspect()\n    |> Map.get(\"choices\")\n    |> Enum.at(0)\n    |> Map.get(\"message\")\n    |> Map.get(\"content\")\n  end\nend\n\nalias OpenaiEx.Notebooks.DlaiOrderbot\n```\n\n```elixir\nmessages = [\n  ChatMessage.system(\"You are an assistant that speaks like Shakespeare.\"),\n  ChatMessage.user(\"tell me a joke\"),\n  ChatMessage.assistant(\"Why did the chicken cross the road\"),\n  ChatMessage.user(\"I don't know\")\n]\n\nreq = DlaiOrderbot.create_chat_req(messages: messages, temperature: 1)\nopenai |> DlaiOrderbot.get_completion(req)\n```\n\n```elixir\nmessages = [\n  ChatMessage.system(\"You are friendly chatbot.\"),\n  ChatMessage.user(\"Hi, my name is Isa\")\n]\n\nreq = DlaiOrderbot.create_chat_req(messages: messages, temperature: 1)\nopenai |> DlaiOrderbot.get_completion(req)\n```\n\n```elixir\nmessages = [\n  ChatMessage.system(\"You are friendly chatbot.\"),\n  ChatMessage.user(\"Yes, can you remind me, What is my name?\")\n]\n\nreq = DlaiOrderbot.create_chat_req(messages: messages, temperature: 1)\nopenai |> DlaiOrderbot.get_completion(req)\n```\n\n```elixir\nmessages = [\n  ChatMessage.system(\"You are friendly chatbot.\"),\n  ChatMessage.user(\"Hi, my name is Isa\"),\n  ChatMessage.assistant(\n    \"Hi Isa! It's nice to meet you. Is there anything I can help you with today?\"\n  ),\n  ChatMessage.user(\"Yes, can you remind me, What is my name?\")\n]\n\nreq = DlaiOrderbot.create_chat_req(messages: messages, temperature: 1)\nopenai |> DlaiOrderbot.get_completion(req)\n```","ref":"dlai_orderbot.html#setup"},{"type":"extras","title":"Order Bot - Deeplearning.AI Order Bot","doc":"We can automate the collection of user prompts and assistant responses to build a OrderBot. The OrderBot will take orders at a pizza restaurant.\n\n```elixir\ncontext = [\n  ChatMessage.system(\"\"\"\n  You are OrderBot, an automated service to collect orders for a pizza restaurant. \\\n  You first greet the customer, then collects the order, \\\n  and then asks if it's a pickup or delivery. \\\n  You wait to collect the entire order, then summarize it and check for a final \\\n  time if the customer wants to add anything else. \\\n  If it's a delivery, you ask for an address. \\\n  Finally you collect the payment.\\\n  Make sure to clarify all options, extras and sizes to uniquely \\\n  identify the item from the menu.\\\n  You respond in a short, very conversational friendly style. \\\n  The menu includes \\\n  pepperoni pizza  12.95, 10.00, 7.00 \\\n  cheese pizza   10.95, 9.25, 6.50 \\\n  eggplant pizza   11.95, 9.75, 6.75 \\\n  fries 4.50, 3.50 \\\n  greek salad 7.25 \\\n  Toppings: \\\n  extra cheese 2.00, \\\n  mushrooms 1.50 \\\n  sausage 3.00 \\\n  canadian bacon 3.50 \\\n  AI sauce 1.50 \\\n  peppers 1.00 \\\n  Drinks: \\\n  coke 3.00, 2.00, 1.00 \\\n  sprite 3.00, 2.00, 1.00 \\\n  bottled water 5.00 \\\n  \"\"\")\n]\n```\n\n```elixir\nappend_completion = fn openai, messages, frame ->\n  req = DlaiOrderbot.create_chat_req(messages: messages)\n  bot_says = openai |> DlaiOrderbot.get_completion(req)\n  Kino.Frame.append(frame, Kino.Text.new(\"#{bot_says}\"))\n  bot_says\nend\n\nchat_frame = Kino.Frame.new()\ninputs = [prompt: Kino.Input.textarea(\"You\")]\nform = Kino.Control.form(inputs, submit: \"Send\", reset_on_submit: [:prompt])\nKino.Frame.render(chat_frame, Kino.Markdown.new(\"#","ref":"dlai_orderbot.html#order-bot"},{"type":"extras","title":"Orderbot Chat\")) - Deeplearning.AI Order Bot","doc":"Kino.Layout.grid([chat_frame, form], boxed: true, gap: 16) |> Kino.render()\n\nbot_says = openai |> append_completion.(context, chat_frame)\n\nKino.listen(\n  form,\n  context ++ [ChatMessage.assistant(bot_says)],\n  fn %{data: %{prompt: you_say}}, history ->\n    Kino.Frame.append(chat_frame, Kino.Markdown.new(\"**You** #{you_say}\"))\n\n    bot_says = openai |> append_completion.(history ++ [ChatMessage.user(you_say)], chat_frame)\n\n    {:cont, history ++ [ChatMessage.user(you_say), ChatMessage.assistant(bot_says)]}\n  end\n)\n```","ref":"dlai_orderbot.html#orderbot-chat"},{"type":"extras","title":"Completions Bot","doc":"# Completions Bot\n\n```elixir\nMix.install([\n  {:openai_ex, \"~> 0.4.1\"},\n  {:kino, \"~> 0.11.0\"}\n])\n\nalias OpenaiEx\nalias OpenaiEx.Completion\n```","ref":"completions.html"},{"type":"extras","title":"Model Choices - Completions Bot","doc":"```elixir\nopenai = System.fetch_env!(\"LB_OPENAI_API_KEY\") |> OpenaiEx.new()\n```\n\n```elixir\ncomp_models = [\n  \"text-davinci-003\",\n  \"text-davinci-002\",\n  \"text-curie-001\",\n  \"text-babbage-001\",\n  \"text-ada-001\"\n]\n```","ref":"completions.html#model-choices"},{"type":"extras","title":"Normal Completion - Completions Bot","doc":"This function calls the completion API and renders the result in the given Kino frame.\n\n```elixir\ncompletion = fn model, prompt, max_tokens, temperature, last_frame ->\n  text =\n    openai\n    |> Completion.create(%{\n      model: model,\n      prompt: prompt,\n      max_tokens: max_tokens,\n      temperature: temperature\n    })\n    |> Map.get(\"choices\")\n    |> Enum.at(0)\n    |> Map.get(\"text\")\n\n  Kino.Frame.render(last_frame, Kino.Markdown.new(\"**Bot** #{text}\"))\n  text\nend\n```","ref":"completions.html#normal-completion"},{"type":"extras","title":"Streaming Completion - Completions Bot","doc":"This function calls the streaming completion API and continously updates the Kino frame with the latest tokens\n\n```elixir\ncompletion_stream = fn model, prompt, max_tokens, temperature, last_frame ->\n  token_stream =\n    openai\n    |> Completion.create(\n      %{\n        model: model,\n        prompt: prompt,\n        max_tokens: max_tokens,\n        temperature: temperature\n      },\n      stream: true\n    )\n    |> Stream.flat_map(& &1)\n    |> Stream.map(fn %{data: data} ->\n      data |> Map.get(\"choices\") |> Enum.at(0) |> Map.get(\"text\")\n    end)\n\n  token_stream\n  |> Enum.reduce(\"\", fn out, acc ->\n    next = acc   out\n    Kino.Frame.render(last_frame, Kino.Markdown.new(\"**Bot** #{next}\"))\n    next\n  end)\nend\n```","ref":"completions.html#streaming-completion"},{"type":"extras","title":"Create a Form UI - Completions Bot","doc":"This is a function to create a Form UI that can be used to call the completion API. The 2nd parameter determines whether the normal or streaming API is called.\n\n```elixir\ncreate_form = fn title, completion_fn ->\n  chat_frame = Kino.Frame.new()\n  last_frame = Kino.Frame.new()\n\n  Kino.Frame.render(chat_frame, Kino.Markdown.new(title))\n\n  inputs = [\n    model: Kino.Input.select(\"Model\", comp_models |> Enum.map(fn x -> {x, x} end)),\n    max_tokens: Kino.Input.number(\"Max Tokens\", default: 400),\n    temperature: Kino.Input.number(\"Temperature\", default: 1),\n    prompt: Kino.Input.textarea(\"Prompt\")\n  ]\n\n  form = Kino.Control.form(inputs, submit: \"Send\", reset_on_submit: [:prompt])\n\n  Kino.listen(\n    form,\n    fn %{\n         data: %{\n           prompt: prompt,\n           model: model,\n           max_tokens: max_tokens,\n           temperature: temperature\n         }\n       } ->\n      Kino.Frame.render(chat_frame, Kino.Markdown.new(title))\n      Kino.Frame.append(chat_frame, Kino.Markdown.new(\"**Me** #{prompt}\"))\n\n      completion_fn.(model, prompt, max_tokens, temperature, last_frame)\n    end\n  )\n\n  Kino.Layout.grid([chat_frame, last_frame, form], boxed: true, gap: 16)\nend\n```\n\n#","ref":"completions.html#create-a-form-ui"},{"type":"extras","title":"Normal Chatbot - Completions Bot","doc":"Create the Form for the non-streaming completion API and use it.\n\n```elixir\ncreate_form.(\"","ref":"completions.html#normal-chatbot"},{"type":"extras","title":"Completion Chatbot\", completion) - Completions Bot","doc":"```\n\n#","ref":"completions.html#completion-chatbot-completion"},{"type":"extras","title":"Streaming Chatbot - Completions Bot","doc":"Create the form for the streaming completion API, and use it.\n\n```elixir\ncreate_form.(\"","ref":"completions.html#streaming-chatbot"},{"type":"extras","title":"Streaming Chatbot\", completion_stream) - Completions Bot","doc":"```","ref":"completions.html#streaming-chatbot-completion_stream"},{"type":"extras","title":"Image Generation Kino App","doc":"# Image Generation Kino App\n\n```elixir\nMix.install([\n  {:openai_ex, \"~> 0.4.1\"},\n  {:kino, \"~> 0.11.0\"}\n])\n\nalias OpenaiEx\nalias OpenaiEx.Image\n```","ref":"images.html"},{"type":"extras","title":"Simple Kino UI - Image Generation Kino App","doc":"```elixir\nopenai = System.fetch_env!(\"LB_OPENAI_API_KEY\") |> OpenaiEx.new()\n```\n\nset default parameters for image generation, and define a function to fetch generated images from a URL.\n\n```elixir\nsize = \"256x256\"\nn = 4\n\nfetch_blob = fn url ->\n  Finch.build(:get, url) |> Finch.request!(OpenaiEx.Finch) |> Map.get(:body)\nend\n```\n\n#","ref":"images.html#simple-kino-ui"},{"type":"extras","title":"Prompt / Response UI - Image Generation Kino App","doc":"```elixir\ntext_input = Kino.Input.textarea(\"Describe Image\")\n\nform = Kino.Control.form([text: text_input], submit: \"Generate\")\nframe = Kino.Frame.new()\n\nKino.listen(form, fn %{data: %{text: prompt}} ->\n  Kino.Frame.render(frame, Kino.Text.new(\"Running...\"))\n\n  res_urls =\n    openai\n    |> Image.create(%{\n      prompt: prompt,\n      n: n,\n      size: size\n    })\n    #   |> IO.inspect()\n    |> Map.get(\"data\")\n    |> Enum.map(fn x -> x[\"url\"] end)\n\n  res_urls\n  |> Enum.map(fn x -> x |> fetch_blob.() |> Kino.Image.new(\"image/png\") end)\n  |> Kino.Layout.grid(columns: 2)\n  |> then(&Kino.Frame.render(frame, &1))\nend)\n\nKino.Layout.grid([form, frame], boxed: true, gap: 16)\n```","ref":"images.html#prompt-response-ui"}],"content_type":"text/markdown"}