searchNodes=[{"type":"module","title":"OpenaiEx","doc":"OpenaiEx is an Elixir library that provides a community-maintained client for the OpenAI API. The library closely follows the structure of the official OpenAI API client libraries for Python and JavaScript , making it easy to understand and reuse existing documentation and code.","ref":"OpenaiEx.html"},{"type":"function","title":"OpenaiEx.new/2","doc":"Creates a new OpenaiEx struct with the specified token and organization. See https://platform.openai.com/docs/api-reference/authentication for details.","ref":"OpenaiEx.html#new/2"},{"type":"function","title":"OpenaiEx.new_file/1","doc":"Create file parameter struct for use in multipart requests. OpenAI API has endpoints which need a file parameter, such as Files and Audio. This function creates a file parameter given a name (optional) and content or a local file path.","ref":"OpenaiEx.html#new_file/1"},{"type":"module","title":"OpenaiEx.Audio","doc":"This module provides an implementation of the OpenAI audio API. The API reference can be found at https://platform.openai.com/docs/api-reference/audio . API Fields The following fields can be used as parameters when creating a new audio request: :file :model :prompt :response_format :temperature :language","ref":"OpenaiEx.Audio.html"},{"type":"function","title":"OpenaiEx.Audio.new/1","doc":"Creates a new audio request with the given arguments. Arguments args : A list of key-value pairs, or a map, representing the fields of the audio request. Returns A map containing the fields of the audio request. The :file and :model fields are required.","ref":"OpenaiEx.Audio.html#new/1"},{"type":"function","title":"OpenaiEx.Audio.transcribe/2","doc":"Calls the audio transcription endpoint. Arguments openai : A map containing the OpenAI configuration. audio : A map containing the audio request. Returns A map containing the audio response. See https://platform.openai.com/docs/api-reference/audio/create for more information.","ref":"OpenaiEx.Audio.html#transcribe/2"},{"type":"function","title":"OpenaiEx.Audio.translate/2","doc":"Calls the audio translation endpoint. Arguments openai : A map containing the OpenAI configuration. audio : A map containing the audio request. Returns A map containing the audio response. See https://platform.openai.com/docs/api-reference/audio/create for more information.","ref":"OpenaiEx.Audio.html#translate/2"},{"type":"module","title":"OpenaiEx.ChatCompletion","doc":"This module provides an implementation of the OpenAI chat completions API. The API reference can be found at https://platform.openai.com/docs/api-reference/chat/completions . API Fields The following fields can be used as parameters when creating a new chat completion: :model :messages :temperature :top_p :n :stop :max_tokens :presence_penalty :frequency_penalty :logit_bias :user","ref":"OpenaiEx.ChatCompletion.html"},{"type":"function","title":"OpenaiEx.ChatCompletion.create/2","doc":"","ref":"OpenaiEx.ChatCompletion.html#create/2"},{"type":"function","title":"OpenaiEx.ChatCompletion.create/3","doc":"Calls the chat completion 'create' endpoint. Arguments openai : The OpenAI configuration. chat_completion : The chat completion request, as a map with keys corresponding to the API fields. Returns A map containing the API response. See https://platform.openai.com/docs/api-reference/chat/completions/create for more information.","ref":"OpenaiEx.ChatCompletion.html#create/3"},{"type":"function","title":"OpenaiEx.ChatCompletion.new/1","doc":"Creates a new chat completion request with the given arguments. Arguments args : A list of key-value pairs, or a map, representing the fields of the chat completion request. Returns A map containing the fields of the chat completion request. The :model and :messages fields are required. The :messages field should be a list of maps with the OpenaiEx.ChatMessage structure. Example usage: iex&gt; _request = OpenaiEx.ChatCompletion . new ( model : &quot;davinci&quot; , messages : [ OpenaiEx.ChatMessage . user ( &quot;Hello, world!&quot; ) ] ) %{ messages : [ %{ content : &quot;Hello, world!&quot; , role : &quot;user&quot; } ] , model : &quot;davinci&quot; } iex&gt; _request = OpenaiEx.ChatCompletion . new ( %{ model : &quot;davinci&quot; , messages : [ OpenaiEx.ChatMessage . user ( &quot;Hello, world!&quot; ) ] } ) %{ messages : [ %{ content : &quot;Hello, world!&quot; , role : &quot;user&quot; } ] , model : &quot;davinci&quot; }","ref":"OpenaiEx.ChatCompletion.html#new/1"},{"type":"module","title":"OpenaiEx.ChatMessage","doc":"This module provides an implementation of the OpenAI chat message API. Information about these messages can be found at https://platform.openai.com/docs/guides/chat/introduction . API Fields The following fields can be used as parameters when creating a new chat message: :content :role","ref":"OpenaiEx.ChatMessage.html"},{"type":"function","title":"OpenaiEx.ChatMessage.assistant/1","doc":"Create a ChatMessage map with role assistant . Example usage: iex&gt; _message = OpenaiEx.ChatMessage . assistant ( &quot;Hello, world!&quot; ) %{ content : &quot;Hello, world!&quot; , role : &quot;assistant&quot; }","ref":"OpenaiEx.ChatMessage.html#assistant/1"},{"type":"function","title":"OpenaiEx.ChatMessage.system/1","doc":"Create a ChatMessage map with role system . Example usage: iex&gt; _message = OpenaiEx.ChatMessage . system ( &quot;Hello, world!&quot; ) %{ content : &quot;Hello, world!&quot; , role : &quot;system&quot; }","ref":"OpenaiEx.ChatMessage.html#system/1"},{"type":"function","title":"OpenaiEx.ChatMessage.user/1","doc":"Create a ChatMessage map with role user . Example usage: iex&gt; _message = OpenaiEx.ChatMessage . user ( &quot;Hello, world!&quot; ) %{ content : &quot;Hello, world!&quot; , role : &quot;user&quot; }","ref":"OpenaiEx.ChatMessage.html#user/1"},{"type":"module","title":"OpenaiEx.Completion","doc":"This module provides an implementation of the OpenAI completions API. The API reference can be found at https://platform.openai.com/docs/api-reference/completions . API Fields The following fields can be used as parameters when creating a new completion: :model :prompt :suffix :max_tokens :temperature :top_p :n :logprobs :echo :stop :presence_penalty :frequency_penalty :best_of :logit_bias :user","ref":"OpenaiEx.Completion.html"},{"type":"function","title":"OpenaiEx.Completion.create/2","doc":"","ref":"OpenaiEx.Completion.html#create/2"},{"type":"function","title":"OpenaiEx.Completion.create/3","doc":"Calls the completion 'create' endpoint. Arguments openai : The OpenAI configuration. completion : The completion request, as a map with keys corresponding to the API fields. Returns A map containing the API response. See https://platform.openai.com/docs/api-reference/completions/create for more information.","ref":"OpenaiEx.Completion.html#create/3"},{"type":"function","title":"OpenaiEx.Completion.new/1","doc":"Creates a new completion request with the given arguments. Arguments args : A list of key-value pairs, or a map, representing the fields of the completion request. Returns A map containing the fields of the completion request. The :model field is required. Example usage: iex&gt; _request = OpenaiEx.Completion . new ( model : &quot;davinci&quot; ) %{ model : &quot;davinci&quot; } iex&gt; _request = OpenaiEx.Completion . new ( %{ model : &quot;davinci&quot; } ) %{ model : &quot;davinci&quot; }","ref":"OpenaiEx.Completion.html#new/1"},{"type":"module","title":"OpenaiEx.Edit","doc":"This module provides an implementation of the OpenAI edits API. The API reference can be found at https://platform.openai.com/docs/api-reference/edits . API Fields The following fields can be used as parameters when creating a new edit: :model :input :instruction :n :temperature :top_p","ref":"OpenaiEx.Edit.html"},{"type":"function","title":"OpenaiEx.Edit.create/2","doc":"Calls the edit endpoint. Arguments openai : The OpenAI configuration. edit : The edit request, as a map with keys corresponding to the API fields. Returns A map containing the fields of the edit response. See https://platform.openai.com/docs/api-reference/edits/create for more information.","ref":"OpenaiEx.Edit.html#create/2"},{"type":"function","title":"OpenaiEx.Edit.new/1","doc":"Creates a new edit request with the given arguments. Arguments args : A list of key-value pairs, or a map, representing the fields of the edit request. Returns A map containing the fields of the edit request. The :model and :instruction fields are required. Example usage: iex&gt; _request = OpenaiEx.Edit . new ( model : &quot;davinci&quot; , instruction : &quot;This is a test&quot; ) %{ instruction : &quot;This is a test&quot; , model : &quot;davinci&quot; } iex&gt; _request = OpenaiEx.Edit . new ( %{ model : &quot;davinci&quot; , instruction : &quot;This is a test&quot; } ) %{ instruction : &quot;This is a test&quot; , model : &quot;davinci&quot; }","ref":"OpenaiEx.Edit.html#new/1"},{"type":"module","title":"OpenaiEx.Embedding","doc":"This module provides an implementation of the OpenAI embeddings API. The API reference can be found at https://platform.openai.com/docs/api-reference/embeddings . API Fields The following fields can be used as parameters when creating a new embedding: :model :input :user","ref":"OpenaiEx.Embedding.html"},{"type":"function","title":"OpenaiEx.Embedding.create/2","doc":"Calls the embedding endpoint. Arguments openai : The OpenAI configuration to use. embedding : The embedding request to send. Returns A map containing the fields of the embedding response. See https://platform.openai.com/docs/api-reference/embeddings/create for more information.","ref":"OpenaiEx.Embedding.html#create/2"},{"type":"function","title":"OpenaiEx.Embedding.new/1","doc":"Creates a new embedding request with the given arguments. Arguments args : A list of key-value pairs, or a map, representing the fields of the embedding request. Returns A map containing the fields of the embedding request. The :model and :input fields are required. Example usage: iex&gt; _request = OpenaiEx.Embedding . new ( model : &quot;davinci&quot; , input : &quot;This is a test&quot; ) %{ input : &quot;This is a test&quot; , model : &quot;davinci&quot; } iex&gt; _request = OpenaiEx.Embedding . new ( %{ model : &quot;davinci&quot; , input : &quot;This is a test&quot; } ) %{ input : &quot;This is a test&quot; , model : &quot;davinci&quot; }","ref":"OpenaiEx.Embedding.html#new/1"},{"type":"module","title":"OpenaiEx.File","doc":"This module provides an implementation of the OpenAI files API. The API reference can be found at https://platform.openai.com/docs/api-reference/files . API Fields The following fields can be used as parameters for various endpoints of the API: :file :purpose :file_id","ref":"OpenaiEx.File.html"},{"type":"function","title":"OpenaiEx.File.create/2","doc":"Calls the file upload endpoint. Arguments openai : The OpenAI configuration. upload : A map containing the fields of the file upload request. Returns A map containing the fields of the file upload response. https://platform.openai.com/docs/api-reference/files/upload","ref":"OpenaiEx.File.html#create/2"},{"type":"function","title":"OpenaiEx.File.delete/2","doc":"Calls the file delete endpoint. Arguments openai : The OpenAI configuration. file_id : The ID of the file to delete. Returns A map containing the fields of the file delete response. https://platform.openai.com/docs/api-reference/files/delete","ref":"OpenaiEx.File.html#delete/2"},{"type":"function","title":"OpenaiEx.File.download/2","doc":"Calls the file retrieve_content endpoint. Arguments openai : The OpenAI configuration. file_id : The ID of the file to retrieve the content of. Returns A map containing the fields of the file retrieve_content response. https://platform.openai.com/docs/api-reference/files/retrieve-content","ref":"OpenaiEx.File.html#download/2"},{"type":"function","title":"OpenaiEx.File.list/1","doc":"Lists the files that belong to the user's organization. https://platform.openai.com/docs/api-reference/files/list","ref":"OpenaiEx.File.html#list/1"},{"type":"function","title":"OpenaiEx.File.new/1","doc":"Creates a new file retrieve / deletion / retrieve_content request with the given arguments. Arguments args : A list of key-value pairs, or a map, representing the fields of the file retrieve / deletion / retrieve_content request. Returns A map containing the fields of the file retrieve / deletion / retrieve_content request. The :file_id field is required.","ref":"OpenaiEx.File.html#new/1"},{"type":"function","title":"OpenaiEx.File.new_upload/1","doc":"Creates a new file upload request with the given arguments. Arguments args : A list of key-value pairs, or a map, representing the fields of the file upload request. Returns A map containing the fields of the file upload request. The :file and :purpose fields are required.","ref":"OpenaiEx.File.html#new_upload/1"},{"type":"function","title":"OpenaiEx.File.retrieve/2","doc":"Calls the file retrieve endpoint. Arguments openai : The OpenAI configuration. file_id : The ID of the file to retrieve. Returns A map containing the fields of the file retrieve response. https://platform.openai.com/docs/api-reference/files/retrieve","ref":"OpenaiEx.File.html#retrieve/2"},{"type":"module","title":"OpenaiEx.FineTune","doc":"This module provides an implementation of the OpenAI fine-tune API. The API reference can be found at https://platform.openai.com/docs/api-reference/fine-tunes . API Fields The following fields can be used as parameters for various endpoints of the API: :training_file :validation_file :model :n_epochs :batch_size :learning_rate_multiplier :prompt_loss_weight :compute_classification_metrics :classification_n_classes :classification_positive_class :classification_betas :suffix :stream","ref":"OpenaiEx.FineTune.html"},{"type":"function","title":"OpenaiEx.FineTune.cancel/2","doc":"Calls the fine-tune cancel endpoint. https://platform.openai.com/docs/api-reference/fine-tunes/cancel","ref":"OpenaiEx.FineTune.html#cancel/2"},{"type":"function","title":"OpenaiEx.FineTune.create/2","doc":"Calls the fine-tune creation endpoint. https://platform.openai.com/docs/api-reference/fine-tunes/create","ref":"OpenaiEx.FineTune.html#create/2"},{"type":"function","title":"OpenaiEx.FineTune.list/1","doc":"Calls the fine-tune list endpoint. https://platform.openai.com/docs/api-reference/fine-tunes/list","ref":"OpenaiEx.FineTune.html#list/1"},{"type":"function","title":"OpenaiEx.FineTune.list_events/2","doc":"Calls the fine-tune list events endpoint. https://platform.openai.com/docs/api-reference/fine-tunes/events","ref":"OpenaiEx.FineTune.html#list_events/2"},{"type":"function","title":"OpenaiEx.FineTune.new/1","doc":"Creates a new fine-tune request with the given arguments. Arguments args : A list of key-value pairs, or a map, representing the fields of the fine-tune request. Returns A map containing the fields of the fine-tune request.","ref":"OpenaiEx.FineTune.html#new/1"},{"type":"function","title":"OpenaiEx.FineTune.retrieve/2","doc":"Calls the fine-tune retrieve endpoint. https://platform.openai.com/docs/api-reference/fine-tunes/retrieve","ref":"OpenaiEx.FineTune.html#retrieve/2"},{"type":"module","title":"OpenaiEx.Image","doc":"This module provides an implementation of the OpenAI images API. The API reference can be found at https://platform.openai.com/docs/api-reference/images . API Fields The following fields can be used as parameters when creating a new image: :prompt :n :size :response_format :user","ref":"OpenaiEx.Image.html"},{"type":"function","title":"OpenaiEx.Image.create/2","doc":"Calls the image generation endpoint. Arguments openai : The OpenAI configuration to use. image : The image request to send. Returns A map containing the response from the OpenAI API. See the OpenAI API Create Image reference for more information.","ref":"OpenaiEx.Image.html#create/2"},{"type":"function","title":"OpenaiEx.Image.create_edit/2","doc":"Calls the image edit endpoint. Arguments openai : The OpenAI configuration to use. image_edit : The image edit request to send. Returns A map containing the response from the OpenAI API. See the OpenAI API Create Image Edit reference for more information.","ref":"OpenaiEx.Image.html#create_edit/2"},{"type":"function","title":"OpenaiEx.Image.create_variation/2","doc":"Calls the image variation endpoint. Arguments openai : The OpenAI configuration to use. image_variation : The image variation request to send. Returns A map containing the response from the OpenAI API. See the OpenAI API Create Image Variation reference for more information.","ref":"OpenaiEx.Image.html#create_variation/2"},{"type":"function","title":"OpenaiEx.Image.new/1","doc":"Creates a new image request with the given arguments. Arguments args : A list of key-value pairs, or a map, representing the fields of the image request. Returns A map containing the fields of the image request. The :prompt field is required. Example usage: iex&gt; _request = OpenaiEx.Image . new ( prompt : &quot;This is a test&quot; ) %{ prompt : &quot;This is a test&quot; } iex&gt; _request = OpenaiEx.Image . new ( %{ prompt : &quot;This is a test&quot; } ) %{ prompt : &quot;This is a test&quot; }","ref":"OpenaiEx.Image.html#new/1"},{"type":"module","title":"OpenaiEx.Image.Edit","doc":"This module provides constructors for OpenAI Image Edit API request structure. The API reference can be found at https://platform.openai.com/docs/api-reference/images/create-edit . API Fields :image :mask :prompt :n :size :response_format :user","ref":"OpenaiEx.Image.Edit.html"},{"type":"function","title":"OpenaiEx.Image.Edit.new/1","doc":"Creates a new image edit request with the given arguments. Arguments args : A list of key-value pairs, or a map, representing the fields of the image edit request. Returns A map containing the fields of the image edit request. The :image and :prompt fields are required.","ref":"OpenaiEx.Image.Edit.html#new/1"},{"type":"module","title":"OpenaiEx.Image.Variation","doc":"This module provides constructors for OpenAI Image Variation API request structure. The API reference can be found at https://platform.openai.com/docs/api-reference/images/create-variation . API Fields :image :n :size :response_format :user","ref":"OpenaiEx.Image.Variation.html"},{"type":"function","title":"OpenaiEx.Image.Variation.new/1","doc":"Creates a new image variation request with the given arguments. Arguments args : A list of key-value pairs, or a map, representing the fields of the image variation request. Returns A map containing the fields of the image variation request. The :image field is required.","ref":"OpenaiEx.Image.Variation.html#new/1"},{"type":"module","title":"OpenaiEx.Model","doc":"This module provides an implementation of the OpenAI Models API. Information about these models can be found at https://platform.openai.com/docs/models .","ref":"OpenaiEx.Model.html"},{"type":"function","title":"OpenaiEx.Model.delete/2","doc":"Deletes a specific model. https://platform.openai.com/docs/api-reference/fine-tunes/delete-model","ref":"OpenaiEx.Model.html#delete/2"},{"type":"function","title":"OpenaiEx.Model.list/1","doc":"Lists the available models. https://platform.openai.com/docs/api-reference/models/list","ref":"OpenaiEx.Model.html#list/1"},{"type":"function","title":"OpenaiEx.Model.retrieve/2","doc":"Retrieves a specific model. https://platform.openai.com/docs/api-reference/models/retrieve","ref":"OpenaiEx.Model.html#retrieve/2"},{"type":"module","title":"OpenaiEx.Moderation","doc":"This module provides an implementation of the OpenAI moderation API. The API reference can be found at https://platform.openai.com/docs/api-reference/moderations . API Fields The following fields can be used as parameters when creating a new moderation: :input :model","ref":"OpenaiEx.Moderation.html"},{"type":"function","title":"OpenaiEx.Moderation.create/2","doc":"Calls the moderation endpoint. Arguments openai : The OpenAI configuration to use. moderation : The moderation request to send. Returns A map containing the fields of the moderation response.","ref":"OpenaiEx.Moderation.html#create/2"},{"type":"function","title":"OpenaiEx.Moderation.new/1","doc":"Creates a new moderation request with the given arguments. Arguments args : A list of key-value pairs, or a map, representing the fields of the moderation request. Returns A map containing the fields of the moderation request. The :input field is required. Example usage: iex&gt; OpenaiEx.Moderation . new ( input : &quot;This is a test&quot; ) %{ input : &quot;This is a test&quot; } iex&gt; OpenaiEx.Moderation . new ( %{ input : &quot;This is a test&quot; } ) %{ input : &quot;This is a test&quot; }","ref":"OpenaiEx.Moderation.html#new/1"},{"type":"extras","title":"OpenaiEx User Guide","doc":"Mix . install ( [ # {:openai_ex, git: &quot;https://github.com/restlessronin/openai_ex.git&quot;, tag: &quot;v0.2.2&quot;}, { :openai_ex , &quot;~&gt; 0.2.2&quot; } , # {:openai_ex, path: Path.join(__DIR__, &quot;..&quot;)}, { :kino , &quot;~&gt; 0.10.0&quot; } ] )","ref":"userguide.html"},{"type":"extras","title":"OpenaiEx User Guide - Introduction","doc":"OpenaiEx is an Elixir library that provides a community-maintained OpenAI API client especially for Livebook development. At this point, all current API endpoints and features are supported, including the streaming version of the completion and chat completion endpoints . There are some differences compared to other elixir openai wrappers. I tried to faithfully mirror the naming/structure of the official python api. For example, content that is already in memory can be uploaded as part of a request, it doesn't have to be read from a file at a local path. I was developing for a livebook use-case, so I don't have any config, only environment variables. Streaming API versions are fully supported. To learn how to use OpenaiEx, you can refer to the relevant parts of the official OpenAI API reference documentation, which we link to throughout this document. This file is an executable Livebook, which means you can interactively run and modify the code samples provided. We encourage you to open it in Livebook and try out the code for yourself!","ref":"userguide.html#introduction"},{"type":"extras","title":"OpenaiEx User Guide - Installation","doc":"You can install OpenaiEx using Mix: In Livebook Add the following code to the first connection cell: Mix . install ( [ { :openai_ex , &quot;~&gt; 0.2.2&quot; } ] , ) In a Mix Project Add the following to your mix.exs file: def deps do [ { :openai_ex , &quot;~&gt; 0.2.2&quot; } ] end","ref":"userguide.html#installation"},{"type":"extras","title":"OpenaiEx User Guide - Authentication","doc":"To authenticate with the OpenAI API, you will need an API key. We recommend storing your API key in an environment variable. Since we are using Livebook, we can store this and other environment variables as Livebook Hub Secrets . apikey = System . fetch_env! ( &quot;LB_OPENAI_API_KEY&quot; ) openai = OpenaiEx . new ( apikey ) You can also specify an organization if you are a member of more than one: # organization = System.fetch_env!(&quot;LB_OPENAI_ORGANIZATION&quot;) # openai = OpenaiEx.new(apikey, organization) For more information on authentication, see the OpenAI API Authentication reference .","ref":"userguide.html#authentication"},{"type":"extras","title":"OpenaiEx User Guide - Model","doc":"List Models To list all available models, use the Model.list() function: alias OpenaiEx.Model openai |&gt; Model . list ( ) Retrieve Models To retrieve information about a specific model, use the Model.retrieve() function: openai |&gt; Model . retrieve ( &quot;text-davinci-003&quot; ) For more information on using models, see the OpenAI API Models reference .","ref":"userguide.html#model"},{"type":"extras","title":"OpenaiEx User Guide - Completion","doc":"To generate a completion, you first need to define a completion request structure using the Completion.new() function. This function takes several parameters, such as the model ID, the prompt, the maximum number of tokens, etc. alias OpenaiEx.Completion completion_req = Completion . new ( model : &quot;text-davinci-003&quot; , prompt : &quot;Give me some background on the elixir language. Why was it created? What is it used for? What distinguishes it from other languages? How popular is it?&quot; , max_tokens : 500 , temperature : 0 ) Once you have defined the completion request structure, you can generate a completion using the Completion.create() function: comp_response = openai |&gt; Completion . create ( completion_req ) You can also call the endpoint and have it return a stream. This returns the result as a series of tokens, which have to be put together in code. To use the stream option, call the Completion.create() function with stream: true completion_stream = openai |&gt; Completion . create ( completion_req , stream : true ) completion_stream |&gt; Stream . flat_map ( &amp; &amp;1 ) |&gt; Enum . each ( fn x -&gt; IO . puts ( inspect ( x ) ) end ) For an example of how to programmatically work with this stream, check out the Completions Bot livebook which builds a ChatBot UI using the Completion API (with and without streaming). For more information on generating completions, see the OpenAI API Completions reference .","ref":"userguide.html#completion"},{"type":"extras","title":"OpenaiEx User Guide - Chat Completion","doc":"To generate a chat completion, you need to define a chat completion request structure using the ChatCompletion.new() function. This function takes several parameters, such as the model ID and a list of chat messages. We have a module ChatMessage which helps create messages in the chat format . alias OpenaiEx.ChatCompletion alias OpenaiEx.ChatMessage chat_req = ChatCompletion . new ( model : &quot;gpt-3.5-turbo&quot; , messages : [ ChatMessage . user ( &quot;Give me some background on the elixir language. Why was it created? What is it used for? What distinguishes it from other languages? How popular is it?&quot; ) ] ) You can generate a chat completion using the ChatCompletion.create() function: chat_response = openai |&gt; ChatCompletion . create ( chat_req ) You can also call the endpoint and have it stream the response. This returns the result as a series of tokens, which have to be put together in code. To use the stream option, call the ChatCompletion.create() function with stream: true chat_stream = openai |&gt; ChatCompletion . create ( chat_req , stream : true ) chat_stream |&gt; Stream . flat_map ( &amp; &amp;1 ) |&gt; Enum . each ( fn x -&gt; IO . puts ( inspect ( x ) ) end ) For a more in-depth example of ChatCompletion , check out the Deeplearning.AI OrderBot Livebook . For a detailed example of the use of the streaming ChatCompletion API, check out Streaming Orderbot , the streaming equivalent of the prior example. For more information on generating chat completions, see the OpenAI API Chat Completions reference .","ref":"userguide.html#chat-completion"},{"type":"extras","title":"OpenaiEx User Guide - Edit","doc":"First you need to define an edit request structure using the Edit.new() function. This function takes several parameters, such as the model ID, an input and an instruction. alias OpenaiEx.Edit edit_req = Edit . new ( model : &quot;text-davinci-edit-001&quot; , input : &quot;What day of the wek is it?&quot; , instruction : &quot;Fix the spelling mistakes&quot; ) To generate the edit, call the Edit.create() function. edit_response = openai |&gt; Edit . create ( edit_req ) For more information on generating edits, see the OpenAI API Edit reference .","ref":"userguide.html#edit"},{"type":"extras","title":"OpenaiEx User Guide - Image","doc":"Generate Image We define the image creation request structure using the Image.new function alias OpenaiEx.Image img_req = Image . new ( prompt : &quot;A cute baby sea otter&quot; , size : &quot;256x256&quot; , n : 2 ) Then call the Image.create() function to generate the images. img_response = openai |&gt; Image . create ( img_req ) For more information on generating images, see the OpenAI API Image reference . Fetch the generated images With the information in the image response, we can fetch the images from their URLs fetch_blob = fn url -&gt; Finch . build ( :get , url ) |&gt; Finch . request! ( OpenaiEx.Finch ) |&gt; Map . get ( :body ) end fetched_images = img_response [ &quot;data&quot; ] |&gt; Enum . map ( fn i -&gt; i [ &quot;url&quot; ] |&gt; fetch_blob . ( ) end ) View the generated images Finally, we can render the images using Kino fetched_images |&gt; Enum . map ( fn r -&gt; r |&gt; Kino.Image . new ( &quot;image/png&quot; ) |&gt; Kino . render ( ) end ) img_to_expmt = fetched_images |&gt; List . first ( ) Edit Image We define an image edit request structure using the Image.Edit.new() function. This function requires an image and a mask. For the image, we will use the one that we received. Let's load the mask from a URL. star_mask = fetch_blob . ( &quot;https://raw.githubusercontent.com/restlessronin/openai_ex/main/assets/images/starmask.png&quot; ) # star_mask = OpenaiEx.new_file(path: Path.join(__DIR__, &quot;../assets/images/starmask.png&quot;)) Set up the image edit request with image, mask and prompt. img_edit_req = Image.Edit . new ( image : img_to_expmt , mask : star_mask , size : &quot;256x256&quot; , prompt : &quot;Image shows a smiling Otter&quot; ) We then call the Image.create_edit() function img_edit_response = openai |&gt; Image . create_edit ( img_edit_req ) and view the result img_edit_response [ &quot;data&quot; ] |&gt; Enum . map ( fn i -&gt; i [ &quot;url&quot; ] |&gt; fetch_blob . ( ) |&gt; Kino.Image . new ( &quot;image/png&quot; ) |&gt; Kino . render ( ) end ) Image Variations We define an image variation request structure using the Image.Variation.new() function. This function requires an image. img_var_req = Image.Variation . new ( image : img_to_expmt , size : &quot;256x256&quot; ) Then call the Image.create_variation() function to generate the images. ### img_var_response = openai |&gt; Image . create_variation ( img_var_req ) img_var_response [ &quot;data&quot; ] |&gt; Enum . map ( fn i -&gt; i [ &quot;url&quot; ] |&gt; fetch_blob . ( ) |&gt; Kino.Image . new ( &quot;image/png&quot; ) |&gt; Kino . render ( ) end ) For more information on images variations, see the OpenAI API Image Variations reference .","ref":"userguide.html#image"},{"type":"extras","title":"OpenaiEx User Guide - Embedding","doc":"Define the embedding request structure using Embedding.new . alias OpenaiEx.Embedding emb_req = Embedding . new ( model : &quot;text-embedding-ada-002&quot; , input : &quot;The food was delicious and the waiter...&quot; ) Then call the Embedding.create() function. emb_response = openai |&gt; Embedding . create ( emb_req ) For more information on generating embeddings, see the OpenAI API Embedding reference","ref":"userguide.html#embedding"},{"type":"extras","title":"OpenaiEx User Guide - Audio","doc":"Transcription To define an Audio request structure, we need to create a file parameter using Audio.File.new() . alias OpenaiEx.Audio audio_url = &quot;https://raw.githubusercontent.com/restlessronin/openai_ex/main/assets/transcribe.mp3&quot; audio_file = OpenaiEx . new_file ( name : audio_url , content : fetch_blob . ( audio_url ) ) # audio_file = OpenaiEx.new_file(path: Path.join(__DIR__, &quot;../assets/transcribe.mp3&quot;)) The file parameter is used to create the Audio request structure audio_req = Audio . new ( file : audio_file , model : &quot;whisper-1&quot; ) We then call the Audio.transcribe() function to create a transcription. audio_response = openai |&gt; Audio . transcribe ( audio_req ) Translation The translation call uses practically the same request structure, but calls the Audio.translate() endpoint For more information on the audio endpoints see the Openai API Audio Reference","ref":"userguide.html#audio"},{"type":"extras","title":"OpenaiEx User Guide - File","doc":"List files To request all files that belong to the user organization, call the File.list() function alias OpenaiEx.File openai |&gt; File . list ( ) Upload files To upload a file, we need to create a file parameter, and then the upload request # fine_tune_file = OpenaiEx.new_file(path: Path.join(__DIR__, &quot;../assets/fine-tune.jsonl&quot;)) ftf_url = &quot;https://raw.githubusercontent.com/restlessronin/openai_ex/main/assets/fine-tune.jsonl&quot; fine_tune_file = OpenaiEx . new_file ( name : ftf_url , content : fetch_blob . ( ftf_url ) ) upload_req = File . new_upload ( file : fine_tune_file , purpose : &quot;fine-tune&quot; ) Then we call the File.create() function to upload the file upload_res = openai |&gt; File . create ( upload_req ) We can verify that the file has been uploaded by calling openai |&gt; File . list ( ) We grab the file id from the previous response value to use in the following samples file_id = upload_res [ &quot;id&quot; ] Retrieve files In order to retrieve meta information on a file, we simply call the File.retrieve() function with the given id openai |&gt; File . retrieve ( file_id ) Retrieve file content Similarly to download the file contents, we call File.download() openai |&gt; File . download ( file_id ) Delete file Finally, we can delete the file by calling File.delete() openai |&gt; File . delete ( file_id ) Verify that the file has been deleted by listing files again openai |&gt; File . list ( )","ref":"userguide.html#file"},{"type":"extras","title":"OpenaiEx User Guide - FineTune","doc":"To run a fine-tune, we minimally need a training file. We will re-run the file creation request above. upload_res = openai |&gt; File . create ( upload_req ) Next we call FineTune.new() to create a new request structure alias OpenaiEx.FineTune ft_req = FineTune . new ( training_file : upload_res [ &quot;id&quot; ] ) To begin the fine tune, we call the FineTune.create() function ft_res = openai |&gt; FineTune . create ( ft_req ) We can list all fine tunes by calling FineTune.list() openai |&gt; FineTune . list ( ) The function FineTune.retrieve() gets the details of a particular fine tune. ft_id = ft_res [ &quot;id&quot; ] openai |&gt; FineTune . retrieve ( fine_tune_id : ft_id ) and FineTune.list_events() can be called to get the events openai |&gt; FineTune . list_events ( fine_tune_id : ft_id ) To cancel a Fine Tune job, call FineTune.cancel() openai |&gt; FineTune . cancel ( fine_tune_id : ft_id ) A fine tuned model can be deleted by calling the Model.delete() ft_model = ft_res [ &quot;fine_tuned_model&quot; ] unless is_nil ( ft_model ) do openai |&gt; Model . delete ( ft_model ) end For more information on the fine tune endpoints see the Openai API Moderation Reference","ref":"userguide.html#finetune"},{"type":"extras","title":"OpenaiEx User Guide - Moderation","doc":"We use the moderation API by calling Moderation.new() to create a new request alias OpenaiEx.Moderation mod_req = Moderation . new ( input : &quot;I want to kill people&quot; ) The call the function Moderation.create() mod_res = openai |&gt; Moderation . create ( mod_req ) For more information on the moderation endpoints see the Openai API Moderation Reference","ref":"userguide.html#moderation"},{"type":"extras","title":"Streaming Orderbot","doc":"Mix . install ( [ { :openai_ex , &quot;~&gt; 0.2.2&quot; } , { :kino , &quot;~&gt; 0.10.0&quot; } ] ) alias OpenaiEx alias OpenaiEx.ChatCompletion alias OpenaiEx.ChatMessage","ref":"streaming_orderbot.html"},{"type":"extras","title":"Streaming Orderbot - Setup","doc":"This notebook creates an Orderbot, similar to the one in Deeplearning.AI Orderbot , but using the streaming version of the Chat Completion API. openai = System . fetch_env! ( &quot;LB_OPENAI_API_KEY&quot; ) |&gt; OpenaiEx . new ( ) defmodule OpenaiEx.Notebooks.StreamingOrderbot do alias OpenaiEx alias OpenaiEx.ChatCompletion def create_chat_req ( args = [ _ | _ ] ) do args |&gt; Enum . into ( %{ model : &quot;gpt-3.5-turbo&quot; , temperature : 0 } ) |&gt; ChatCompletion . new ( ) end def get_completion_stream ( openai = % OpenaiEx { } , cc_req = %{ } ) do openai |&gt; ChatCompletion . create ( cc_req , stream : true ) |&gt; Stream . flat_map ( &amp; &amp;1 ) |&gt; Stream . map ( fn %{ data : d } -&gt; d |&gt; Map . get ( &quot;choices&quot; ) |&gt; Enum . at ( 0 ) |&gt; Map . get ( &quot;delta&quot; ) end ) |&gt; Stream . filter ( fn map -&gt; map |&gt; Map . has_key? ( &quot;content&quot; ) end ) |&gt; Stream . map ( fn map -&gt; map |&gt; Map . get ( &quot;content&quot; ) end ) end def stream_completion_to_frame ( openai = % OpenaiEx { } , messages , frame ) do openai |&gt; get_completion_stream ( create_chat_req ( messages : messages ) ) |&gt; Enum . reduce ( &quot;&quot; , fn token , text -&gt; next = text &lt;&gt; token Kino.Frame . render ( frame , Kino.Text . new ( next ) ) next end ) end def create_orderbot ( openai = % OpenaiEx { } , context ) do chat_frame = Kino.Frame . new ( ) last_frame = Kino.Frame . new ( ) inputs = [ prompt : Kino.Input . textarea ( &quot;You&quot; ) ] form = Kino.Control . form ( inputs , submit : &quot;Send&quot; , reset_on_submit : [ :prompt ] ) Kino.Frame . render ( chat_frame , Kino.Markdown . new ( &quot;### Orderbot Chat&quot; ) ) Kino.Layout . grid ( [ chat_frame , last_frame , form ] , boxed : true , gap : 16 ) |&gt; Kino . render ( ) bot_says = openai |&gt; stream_completion_to_frame ( context , last_frame ) Kino . listen ( form , context ++ [ ChatMessage . assistant ( bot_says ) ] , fn %{ data : %{ prompt : you_say } } , history -&gt; Kino.Frame . render ( last_frame , Kino.Text . new ( &quot;&quot; ) ) Kino.Frame . append ( chat_frame , Kino.Text . new ( List . last ( history ) . content ) ) Kino.Frame . append ( chat_frame , Kino.Markdown . new ( &quot;**You** \#{ you_say } &quot; ) ) bot_says = openai |&gt; stream_completion_to_frame ( history ++ [ ChatMessage . user ( you_say ) ] , last_frame ) { :cont , history ++ [ ChatMessage . user ( you_say ) , ChatMessage . assistant ( bot_says ) ] } end ) end end alias OpenaiEx.Notebooks.StreamingOrderbot","ref":"streaming_orderbot.html#setup"},{"type":"extras","title":"Streaming Orderbot - Orderbot","doc":"context = [ ChatMessage . system ( &quot;&quot;&quot; You are OrderBot, an automated service to collect orders for a pizza restaurant. \\ You first greet the customer, then collects the order, \\ and then asks if it&#39;s a pickup or delivery. \\ You wait to collect the entire order, then summarize it and check for a final \\ time if the customer wants to add anything else. \\ If it&#39;s a delivery, you ask for an address. \\ Finally you collect the payment. \\ Make sure to clarify all options, extras and sizes to uniquely \\ identify the item from the menu. \\ You respond in a short, very conversational friendly style. \\ The menu includes \\ pepperoni pizza 12.95, 10.00, 7.00 \\ cheese pizza 10.95, 9.25, 6.50 \\ eggplant pizza 11.95, 9.75, 6.75 \\ fries 4.50, 3.50 \\ greek salad 7.25 \\ Toppings: \\ extra cheese 2.00, \\ mushrooms 1.50 \\ sausage 3.00 \\ canadian bacon 3.50 \\ AI sauce 1.50 \\ peppers 1.00 \\ Drinks: \\ coke 3.00, 2.00, 1.00 \\ sprite 3.00, 2.00, 1.00 \\ bottled water 5.00 \\ &quot;&quot;&quot; ) ] openai |&gt; StreamingOrderbot . create_orderbot ( context )","ref":"streaming_orderbot.html#orderbot"},{"type":"extras","title":"Deeplearning.AI Order Bot","doc":"Mix . install ( [ { :openai_ex , &quot;~&gt; 0.2.2&quot; } , { :kino , &quot;~&gt; 0.10.0&quot; } ] ) alias OpenaiEx alias OpenaiEx.ChatCompletion alias OpenaiEx.ChatMessage","ref":"dlai_orderbot.html"},{"type":"extras","title":"Deeplearning.AI Order Bot - Source","doc":"This notebook is an elixir translation of the python notebook in Lesson 8 , of Deeplearning.AI 's course ChatGPT Prompt Engineering for Developers .","ref":"dlai_orderbot.html#source"},{"type":"extras","title":"Deeplearning.AI Order Bot - Chat Format","doc":"In this notebook, you will explore how you can utilize the chat format to have extended conversations with chatbots personalized or specialized for specific tasks or behaviors. Setup openai = System . fetch_env! ( &quot;LB_OPENAI_API_KEY&quot; ) |&gt; OpenaiEx . new ( ) defmodule OpenaiEx.Notebooks.DlaiOrderbot do alias OpenaiEx alias OpenaiEx.ChatCompletion def create_chat_req ( args = [ _ | _ ] ) do args |&gt; Enum . into ( %{ model : &quot;gpt-3.5-turbo&quot; , temperature : 0 } ) |&gt; ChatCompletion . new ( ) end def get_completion ( openai = % OpenaiEx { } , cc_req = %{ } ) do openai |&gt; ChatCompletion . create ( cc_req ) # for debugging # |&gt; IO.inspect() |&gt; Map . get ( &quot;choices&quot; ) |&gt; Enum . at ( 0 ) |&gt; Map . get ( &quot;message&quot; ) |&gt; Map . get ( &quot;content&quot; ) end end alias OpenaiEx.Notebooks.DlaiOrderbot messages = [ ChatMessage . system ( &quot;You are an assistant that speaks like Shakespeare.&quot; ) , ChatMessage . user ( &quot;tell me a joke&quot; ) , ChatMessage . assistant ( &quot;Why did the chicken cross the road&quot; ) , ChatMessage . user ( &quot;I don&#39;t know&quot; ) ] req = DlaiOrderbot . create_chat_req ( messages : messages , temperature : 1 ) openai |&gt; DlaiOrderbot . get_completion ( req ) messages = [ ChatMessage . system ( &quot;You are friendly chatbot.&quot; ) , ChatMessage . user ( &quot;Hi, my name is Isa&quot; ) ] req = DlaiOrderbot . create_chat_req ( messages : messages , temperature : 1 ) openai |&gt; DlaiOrderbot . get_completion ( req ) messages = [ ChatMessage . system ( &quot;You are friendly chatbot.&quot; ) , ChatMessage . user ( &quot;Yes, can you remind me, What is my name?&quot; ) ] req = DlaiOrderbot . create_chat_req ( messages : messages , temperature : 1 ) openai |&gt; DlaiOrderbot . get_completion ( req ) messages = [ ChatMessage . system ( &quot;You are friendly chatbot.&quot; ) , ChatMessage . user ( &quot;Hi, my name is Isa&quot; ) , ChatMessage . assistant ( &quot;Hi Isa! It&#39;s nice to meet you. Is there anything I can help you with today?&quot; ) , ChatMessage . user ( &quot;Yes, can you remind me, What is my name?&quot; ) ] req = DlaiOrderbot . create_chat_req ( messages : messages , temperature : 1 ) openai |&gt; DlaiOrderbot . get_completion ( req )","ref":"dlai_orderbot.html#chat-format"},{"type":"extras","title":"Deeplearning.AI Order Bot - Order Bot","doc":"We can automate the collection of user prompts and assistant responses to build a OrderBot. The OrderBot will take orders at a pizza restaurant. context = [ ChatMessage . system ( &quot;&quot;&quot; You are OrderBot, an automated service to collect orders for a pizza restaurant. \\ You first greet the customer, then collects the order, \\ and then asks if it&#39;s a pickup or delivery. \\ You wait to collect the entire order, then summarize it and check for a final \\ time if the customer wants to add anything else. \\ If it&#39;s a delivery, you ask for an address. \\ Finally you collect the payment. \\ Make sure to clarify all options, extras and sizes to uniquely \\ identify the item from the menu. \\ You respond in a short, very conversational friendly style. \\ The menu includes \\ pepperoni pizza 12.95, 10.00, 7.00 \\ cheese pizza 10.95, 9.25, 6.50 \\ eggplant pizza 11.95, 9.75, 6.75 \\ fries 4.50, 3.50 \\ greek salad 7.25 \\ Toppings: \\ extra cheese 2.00, \\ mushrooms 1.50 \\ sausage 3.00 \\ canadian bacon 3.50 \\ AI sauce 1.50 \\ peppers 1.00 \\ Drinks: \\ coke 3.00, 2.00, 1.00 \\ sprite 3.00, 2.00, 1.00 \\ bottled water 5.00 \\ &quot;&quot;&quot; ) ] append_completion = fn openai , messages , frame -&gt; req = DlaiOrderbot . create_chat_req ( messages : messages ) bot_says = openai |&gt; DlaiOrderbot . get_completion ( req ) Kino.Frame . append ( frame , Kino.Text . new ( &quot; \#{ bot_says } &quot; ) ) bot_says end chat_frame = Kino.Frame . new ( ) inputs = [ prompt : Kino.Input . textarea ( &quot;You&quot; ) ] form = Kino.Control . form ( inputs , submit : &quot;Send&quot; , reset_on_submit : [ :prompt ] ) Kino.Frame . render ( chat_frame , Kino.Markdown . new ( &quot;### Orderbot Chat&quot; ) ) Kino.Layout . grid ( [ chat_frame , form ] , boxed : true , gap : 16 ) |&gt; Kino . render ( ) bot_says = openai |&gt; append_completion . ( context , chat_frame ) Kino . listen ( form , context ++ [ ChatMessage . assistant ( bot_says ) ] , fn %{ data : %{ prompt : you_say } } , history -&gt; Kino.Frame . append ( chat_frame , Kino.Markdown . new ( &quot;**You** \#{ you_say } &quot; ) ) bot_says = openai |&gt; append_completion . ( history ++ [ ChatMessage . user ( you_say ) ] , chat_frame ) { :cont , history ++ [ ChatMessage . user ( you_say ) , ChatMessage . assistant ( bot_says ) ] } end )","ref":"dlai_orderbot.html#order-bot"},{"type":"extras","title":"Completions Bot","doc":"Mix . install ( [ { :openai_ex , &quot;~&gt; 0.2.2&quot; } , { :kino , &quot;~&gt; 0.10.0&quot; } ] ) alias OpenaiEx alias OpenaiEx.Completion","ref":"completions.html"},{"type":"extras","title":"Completions Bot - Model Choices","doc":"openai = System . fetch_env! ( &quot;LB_OPENAI_API_KEY&quot; ) |&gt; OpenaiEx . new ( ) comp_models = [ &quot;text-davinci-003&quot; , &quot;text-davinci-002&quot; , &quot;text-curie-001&quot; , &quot;text-babbage-001&quot; , &quot;text-ada-001&quot; ]","ref":"completions.html#model-choices"},{"type":"extras","title":"Completions Bot - Normal Completion","doc":"This function calls the completion API and renders the result in the given Kino frame. completion = fn model , prompt , max_tokens , temperature , last_frame -&gt; text = openai |&gt; Completion . create ( %{ model : model , prompt : prompt , max_tokens : max_tokens , temperature : temperature } ) |&gt; Map . get ( &quot;choices&quot; ) |&gt; Enum . at ( 0 ) |&gt; Map . get ( &quot;text&quot; ) Kino.Frame . render ( last_frame , Kino.Markdown . new ( &quot;**Bot** \#{ text } &quot; ) ) text end","ref":"completions.html#normal-completion"},{"type":"extras","title":"Completions Bot - Streaming Completion","doc":"This function calls the streaming completion API and continously updates the Kino frame with the latest tokens completion_stream = fn model , prompt , max_tokens , temperature , last_frame -&gt; token_stream = openai |&gt; Completion . create ( %{ model : model , prompt : prompt , max_tokens : max_tokens , temperature : temperature } , stream : true ) |&gt; Stream . flat_map ( &amp; &amp;1 ) |&gt; Stream . map ( fn %{ data : data } -&gt; data |&gt; Map . get ( &quot;choices&quot; ) |&gt; Enum . at ( 0 ) |&gt; Map . get ( &quot;text&quot; ) end ) token_stream |&gt; Enum . reduce ( fn out , acc -&gt; next = acc &lt;&gt; out Kino.Frame . render ( last_frame , Kino.Markdown . new ( &quot;**Bot** \#{ next } &quot; ) ) next end ) end","ref":"completions.html#streaming-completion"},{"type":"extras","title":"Completions Bot - Create a Form UI","doc":"This is a function to create a Form UI that can be used to call the completion API. The 2nd parameter determines whether the normal or streaming API is called. create_form = fn title , completion_fn -&gt; chat_frame = Kino.Frame . new ( ) last_frame = Kino.Frame . new ( ) Kino.Frame . render ( chat_frame , Kino.Markdown . new ( title ) ) inputs = [ model : Kino.Input . select ( &quot;Model&quot; , comp_models |&gt; Enum . map ( fn x -&gt; { x , x } end ) ) , max_tokens : Kino.Input . number ( &quot;Max Tokens&quot; , default : 400 ) , temperature : Kino.Input . number ( &quot;Temperature&quot; , default : 1 ) , prompt : Kino.Input . textarea ( &quot;Prompt&quot; ) ] form = Kino.Control . form ( inputs , submit : &quot;Send&quot; , reset_on_submit : [ :prompt ] ) Kino . listen ( form , fn %{ data : %{ prompt : prompt , model : model , max_tokens : max_tokens , temperature : temperature } } -&gt; Kino.Frame . render ( chat_frame , Kino.Markdown . new ( title ) ) Kino.Frame . append ( chat_frame , Kino.Markdown . new ( &quot;**Me** \#{ prompt } &quot; ) ) completion_fn . ( model , prompt , max_tokens , temperature , last_frame ) end ) Kino.Layout . grid ( [ chat_frame , last_frame , form ] , boxed : true , gap : 16 ) end Normal Chatbot Create the Form for the non-streaming completion API and use it. create_form . ( &quot;## Completion Chatbot&quot; , completion ) Streaming Chatbot Create the form for the streaming completion API, and use it. create_form . ( &quot;## Streaming Chatbot&quot; , completion_stream )","ref":"completions.html#create-a-form-ui"},{"type":"extras","title":"Image Generation Kino App","doc":"Mix . install ( [ { :openai_ex , &quot;~&gt; 0.2.2&quot; } , { :kino , &quot;~&gt; 0.9.2&quot; } ] ) alias OpenaiEx alias OpenaiEx.Image","ref":"images.html"},{"type":"extras","title":"Image Generation Kino App - Simple Kino UI","doc":"openai = System . fetch_env! ( &quot;LB_OPENAI_API_KEY&quot; ) |&gt; OpenaiEx . new ( ) set default parameters for image generation, and define a function to fetch generated images from a URL. size = &quot;256x256&quot; n = 4 fetch_blob = fn url -&gt; Finch . build ( :get , url ) |&gt; Finch . request! ( OpenaiEx.Finch ) |&gt; Map . get ( :body ) end Prompt / Response UI text_input = Kino.Input . textarea ( &quot;Describe Image&quot; ) form = Kino.Control . form ( [ text : text_input ] , submit : &quot;Generate&quot; ) frame = Kino.Frame . new ( ) Kino . listen ( form , fn %{ data : %{ text : prompt } } -&gt; Kino.Frame . render ( frame , Kino.Text . new ( &quot;Running...&quot; ) ) res_urls = openai |&gt; Image . create ( %{ prompt : prompt , n : n , size : size } ) # |&gt; IO.inspect() |&gt; Map . get ( &quot;data&quot; ) |&gt; Enum . map ( fn x -&gt; x [ &quot;url&quot; ] end ) res_urls |&gt; Enum . map ( fn x -&gt; x |&gt; fetch_blob . ( ) |&gt; Kino.Image . new ( &quot;image/png&quot; ) end ) |&gt; Kino.Layout . grid ( columns : 2 ) |&gt; then ( &amp; Kino.Frame . render ( frame , &amp;1 ) ) end ) Kino.Layout . grid ( [ form , frame ] , boxed : true , gap : 16 )","ref":"images.html#simple-kino-ui"}]